type _SIZE_T_TYPE = bv32;

procedure _ATOMIC_OP32(_P$1: bool, x$1: [bv32]bv32, y$1: bv32, _P$2: bool, x$2: [bv32]bv32, y$2: bv32) returns (z$1: bv32, A$1: [bv32]bv32, z$2: bv32, A$2: [bv32]bv32);



var {:original_name "input"} {:global} $$input: [bv32]bv32;

var {:race_checking} {:global} {:elem_width 32} _READ_HAS_OCCURRED_$$input: bool;

var {:race_checking} {:global} {:elem_width 32} _WRITE_HAS_OCCURRED_$$input: bool;

var {:race_checking} {:global} {:elem_width 32} _ATOMIC_HAS_OCCURRED_$$input: bool;

var {:race_checking} {:global} _READ_OFFSET_$$input: bv32;

var {:race_checking} {:global} _WRITE_OFFSET_$$input: bv32;

var {:race_checking} {:global} _ATOMIC_OFFSET_$$input: bv32;

var {:original_name "counter"} {:global} $$counter: [bv32]bv32;

var {:race_checking} {:global} {:elem_width 32} _READ_HAS_OCCURRED_$$counter: bool;

var {:race_checking} {:global} {:elem_width 32} _WRITE_HAS_OCCURRED_$$counter: bool;

var {:race_checking} {:global} {:elem_width 32} _ATOMIC_HAS_OCCURRED_$$counter: bool;

var {:race_checking} {:global} _READ_OFFSET_$$counter: bv32;

var {:race_checking} {:global} _WRITE_OFFSET_$$counter: bv32;

var {:race_checking} {:global} _ATOMIC_OFFSET_$$counter: bv32;

const {:group_id_x} group_id_x$1: bv32;

const {:group_id_x} group_id_x$2: bv32;

const {:group_size_x} group_size_x: bv32;

const {:group_size_y} group_size_y: bv32;

const {:group_size_z} group_size_z: bv32;

const {:local_id_x} local_id_x$1: bv32;

const {:local_id_x} local_id_x$2: bv32;

const {:num_groups_x} num_groups_x: bv32;

const {:num_groups_y} num_groups_y: bv32;

const {:num_groups_z} num_groups_z: bv32;

function {:bvbuiltin "bvadd"} BV32_ADD(bv32, bv32) : bv32;

function {:bvbuiltin "bvmul"} BV32_MUL(bv32, bv32) : bv32;

procedure {:original_name "atomicCounters"} {:kernel} $atomicCounters(_P$1: bool, $value$1: bv32, _P$2: bool, $value$2: bv32);
  requires !_READ_HAS_OCCURRED_$$input && !_WRITE_HAS_OCCURRED_$$input && !_ATOMIC_HAS_OCCURRED_$$input;
  requires !_READ_HAS_OCCURRED_$$counter && !_WRITE_HAS_OCCURRED_$$counter && !_ATOMIC_HAS_OCCURRED_$$counter;
  requires BV32_SGT(group_size_x, 0bv32);
  requires BV32_SGT(num_groups_x, 0bv32);
  requires BV32_SGE(group_id_x$1, 0bv32);
  requires BV32_SGE(group_id_x$2, 0bv32);
  requires BV32_SLT(group_id_x$1, num_groups_x);
  requires BV32_SLT(group_id_x$2, num_groups_x);
  requires BV32_SGE(local_id_x$1, 0bv32);
  requires BV32_SGE(local_id_x$2, 0bv32);
  requires BV32_SLT(local_id_x$1, group_size_x);
  requires BV32_SLT(local_id_x$2, group_size_x);
  requires BV32_SGT(group_size_y, 0bv32);
  requires BV32_SGT(num_groups_y, 0bv32);
  requires BV32_SGE(group_id_y$1, 0bv32);
  requires BV32_SGE(group_id_y$2, 0bv32);
  requires BV32_SLT(group_id_y$1, num_groups_y);
  requires BV32_SLT(group_id_y$2, num_groups_y);
  requires BV32_SGE(local_id_y$1, 0bv32);
  requires BV32_SGE(local_id_y$2, 0bv32);
  requires BV32_SLT(local_id_y$1, group_size_y);
  requires BV32_SLT(local_id_y$2, group_size_y);
  requires BV32_SGT(group_size_z, 0bv32);
  requires BV32_SGT(num_groups_z, 0bv32);
  requires BV32_SGE(group_id_z$1, 0bv32);
  requires BV32_SGE(group_id_z$2, 0bv32);
  requires BV32_SLT(group_id_z$1, num_groups_z);
  requires BV32_SLT(group_id_z$2, num_groups_z);
  requires BV32_SGE(local_id_z$1, 0bv32);
  requires BV32_SGE(local_id_z$2, 0bv32);
  requires BV32_SLT(local_id_z$1, group_size_z);
  requires BV32_SLT(local_id_z$2, group_size_z);
  requires group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 ==> local_id_x$1 != local_id_x$2 || local_id_y$1 != local_id_y$2 || local_id_z$1 != local_id_z$2;
  requires _P$1 == _P$2;
  requires $value$1 == $value$2;
  modifies _USED_$$counter, _READ_HAS_OCCURRED_$$input, _READ_OFFSET_$$input, _READ_VALUE_$$input, _ATOMIC_HAS_OCCURRED_$$counter, _ATOMIC_OFFSET_$$counter;



implementation {:original_name "atomicCounters"} {:kernel} $atomicCounters(_P$1: bool, $value$1: bv32, _P$2: bool, $value$2: bv32)
{
  var v0$1: bv32;
  var v0$2: bv32;
  var v1$1: bool;
  var v1$2: bool;
  var v2$1: bv32;
  var v2$2: bv32;
  var p0$1: bool;
  var p0$2: bool;
  var p1$1: bool;
  var p1$2: bool;
  var _HAVOC_bv32$1: bv32;
  var _HAVOC_bv32$2: bv32;


  $0:
    call {:sourceloc} {:sourceloc_num 0} _LOG_READ_$$input(_P$1, BV32_ADD(BV32_MUL(group_size_x, group_id_x$1), local_id_x$1), $$input[BV32_ADD(BV32_MUL(group_size_x, group_id_x$1), local_id_x$1)]);
    assume {:do_not_predicate} {:check_id "check_state_0"} {:captureState "check_state_0"} {:sourceloc} {:sourceloc_num 0} true;
    call {:check_id "check_state_0"} {:sourceloc} {:sourceloc_num 0} _CHECK_READ_$$input(_P$2, BV32_ADD(BV32_MUL(group_size_x, group_id_x$2), local_id_x$2), $$input[BV32_ADD(BV32_MUL(group_size_x, group_id_x$2), local_id_x$2)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$input"} true;
    v0$1 := (if _P$1 then $$input[BV32_ADD(BV32_MUL(group_size_x, group_id_x$1), local_id_x$1)] else v0$1);
    v0$2 := (if _P$2 then $$input[BV32_ADD(BV32_MUL(group_size_x, group_id_x$2), local_id_x$2)] else v0$2);
    v1$1 := (if _P$1 then $value$1 == v0$1 else v1$1);
    v1$2 := (if _P$2 then $value$2 == v0$2 else v1$2);
    p0$1 := false;
    p0$2 := false;
    p1$1 := false;
    p1$2 := false;
    p0$1 := (if _P$1 then v1$1 else p0$1);
    p0$2 := (if _P$2 then v1$2 else p0$2);
    call {:sourceloc} {:sourceloc_num 1} {:atomic} {:atomic_function "__atomic_inc_global_unsigned_int"} {:parts 1} {:part 1} _LOG_ATOMIC_$$counter(p0$1, 0bv32);
    assume {:do_not_predicate} {:check_id "check_state_1"} {:captureState "check_state_1"} {:sourceloc} {:sourceloc_num 1} true;
    call {:check_id "check_state_1"} {:sourceloc} {:sourceloc_num 1} {:atomic} {:atomic_function "__atomic_inc_global_unsigned_int"} {:parts 1} {:part 1} _CHECK_ATOMIC_$$counter(p0$2, 0bv32);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_ATOMIC_$$counter"} true;
    havoc _HAVOC_bv32$1, _HAVOC_bv32$2;
    v2$1 := (if p0$1 then _HAVOC_bv32$1 else v2$1);
    v2$2 := (if p0$2 then _HAVOC_bv32$2 else v2$2);
    assume !_USED_$$counter[0bv32][v2$1];
    _USED_$$counter[0bv32][v2$1] := true;
    assume !_USED_$$counter[0bv32][v2$2];
    _USED_$$counter[0bv32][v2$2] := true;
    return;
}



axiom (if group_size_y == 1bv32 then 1bv1 else 0bv1) != 0bv1;

axiom (if group_size_z == 1bv32 then 1bv1 else 0bv1) != 0bv1;

axiom (if num_groups_y == 1bv32 then 1bv1 else 0bv1) != 0bv1;

axiom (if num_groups_z == 1bv32 then 1bv1 else 0bv1) != 0bv1;

axiom (if group_size_x == 64bv32 then 1bv1 else 0bv1) != 0bv1;

axiom (if num_groups_x == 64bv32 then 1bv1 else 0bv1) != 0bv1;

const {:local_id_y} local_id_y$1: bv32;

const {:local_id_y} local_id_y$2: bv32;

const {:local_id_z} local_id_z$1: bv32;

const {:local_id_z} local_id_z$2: bv32;

const {:group_id_y} group_id_y$1: bv32;

const {:group_id_y} group_id_y$2: bv32;

const {:group_id_z} group_id_z$1: bv32;

const {:group_id_z} group_id_z$2: bv32;

var {:atomic_usedmap} _USED_$$counter: [bv32][bv32]bool;

var _READ_VALUE_$$input: bv32;

procedure {:inline 1} _LOG_READ_$$input(_P: bool, _offset: bv32, _value: bv32);
  modifies _READ_HAS_OCCURRED_$$input, _READ_OFFSET_$$input, _READ_VALUE_$$input;



implementation {:inline 1} _LOG_READ_$$input(_P: bool, _offset: bv32, _value: bv32)
{
  var track: bool;


  _LOG_READ:
    havoc track;
    _READ_HAS_OCCURRED_$$input := (if _P && track then true else _READ_HAS_OCCURRED_$$input);
    _READ_OFFSET_$$input := (if _P && track then _offset else _READ_OFFSET_$$input);
    _READ_VALUE_$$input := (if _P && track then _value else _READ_VALUE_$$input);
    return;
}



procedure _CHECK_READ_$$input(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "input"} {:array "$$input"} {:race} {:write_read} !(_P && _WRITE_HAS_OCCURRED_$$input && _WRITE_OFFSET_$$input == _offset && _WRITE_READ_BENIGN_FLAG_$$input);
  requires {:original_name "input"} {:array "$$input"} {:race} {:atomic_read} !(_P && _ATOMIC_HAS_OCCURRED_$$input && _ATOMIC_OFFSET_$$input == _offset);



var _WRITE_VALUE_$$input: bv32;

var _WRITE_READ_BENIGN_FLAG_$$input: bool;

procedure {:inline 1} _LOG_WRITE_$$input(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32);
  modifies _WRITE_HAS_OCCURRED_$$input, _WRITE_OFFSET_$$input, _WRITE_VALUE_$$input, _WRITE_READ_BENIGN_FLAG_$$input;



implementation {:inline 1} _LOG_WRITE_$$input(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32)
{
  var track: bool;


  _LOG_WRITE:
    havoc track;
    _WRITE_HAS_OCCURRED_$$input := (if _P && track then true else _WRITE_HAS_OCCURRED_$$input);
    _WRITE_OFFSET_$$input := (if _P && track then _offset else _WRITE_OFFSET_$$input);
    _WRITE_VALUE_$$input := (if _P && track then _value else _WRITE_VALUE_$$input);
    _WRITE_READ_BENIGN_FLAG_$$input := (if _P && track then _value != _value_old else _WRITE_READ_BENIGN_FLAG_$$input);
    return;
}



procedure _CHECK_WRITE_$$input(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "input"} {:array "$$input"} {:race} {:write_write} !(_P && _WRITE_HAS_OCCURRED_$$input && _WRITE_OFFSET_$$input == _offset && _WRITE_VALUE_$$input != _value);
  requires {:original_name "input"} {:array "$$input"} {:race} {:read_write} !(_P && _READ_HAS_OCCURRED_$$input && _READ_OFFSET_$$input == _offset && _READ_VALUE_$$input != _value);
  requires {:original_name "input"} {:array "$$input"} {:race} {:atomic_write} !(_P && _ATOMIC_HAS_OCCURRED_$$input && _ATOMIC_OFFSET_$$input == _offset);



procedure {:inline 1} _LOG_ATOMIC_$$input(_P: bool, _offset: bv32);
  modifies _ATOMIC_HAS_OCCURRED_$$input, _ATOMIC_OFFSET_$$input;



implementation {:inline 1} _LOG_ATOMIC_$$input(_P: bool, _offset: bv32)
{
  var track: bool;


  _LOG_ATOMIC:
    havoc track;
    _ATOMIC_HAS_OCCURRED_$$input := (if _P && track then true else _ATOMIC_HAS_OCCURRED_$$input);
    _ATOMIC_OFFSET_$$input := (if _P && track then _offset else _ATOMIC_OFFSET_$$input);
    return;
}



procedure _CHECK_ATOMIC_$$input(_P: bool, _offset: bv32);
  requires {:original_name "input"} {:array "$$input"} {:race} {:write_atomic} !(_P && _WRITE_HAS_OCCURRED_$$input && _WRITE_OFFSET_$$input == _offset);
  requires {:original_name "input"} {:array "$$input"} {:race} {:read_atomic} !(_P && _READ_HAS_OCCURRED_$$input && _READ_OFFSET_$$input == _offset);



procedure {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$input(_P: bool, _offset: bv32);
  modifies _WRITE_READ_BENIGN_FLAG_$$input;



implementation {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$input(_P: bool, _offset: bv32)
{

  _UPDATE_BENIGN_FLAG:
    _WRITE_READ_BENIGN_FLAG_$$input := (if _P && _WRITE_HAS_OCCURRED_$$input && _WRITE_OFFSET_$$input == _offset then false else _WRITE_READ_BENIGN_FLAG_$$input);
    return;
}



var _READ_VALUE_$$counter: bv32;

procedure {:inline 1} _LOG_READ_$$counter(_P: bool, _offset: bv32, _value: bv32);
  modifies _READ_HAS_OCCURRED_$$counter, _READ_OFFSET_$$counter, _READ_VALUE_$$counter;



implementation {:inline 1} _LOG_READ_$$counter(_P: bool, _offset: bv32, _value: bv32)
{
  var track: bool;


  _LOG_READ:
    havoc track;
    _READ_HAS_OCCURRED_$$counter := (if _P && track then true else _READ_HAS_OCCURRED_$$counter);
    _READ_OFFSET_$$counter := (if _P && track then _offset else _READ_OFFSET_$$counter);
    _READ_VALUE_$$counter := (if _P && track then _value else _READ_VALUE_$$counter);
    return;
}



procedure _CHECK_READ_$$counter(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "counter"} {:array "$$counter"} {:race} {:write_read} !(_P && _WRITE_HAS_OCCURRED_$$counter && _WRITE_OFFSET_$$counter == _offset && _WRITE_READ_BENIGN_FLAG_$$counter);
  requires {:original_name "counter"} {:array "$$counter"} {:race} {:atomic_read} !(_P && _ATOMIC_HAS_OCCURRED_$$counter && _ATOMIC_OFFSET_$$counter == _offset);



var _WRITE_VALUE_$$counter: bv32;

var _WRITE_READ_BENIGN_FLAG_$$counter: bool;

procedure {:inline 1} _LOG_WRITE_$$counter(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32);
  modifies _WRITE_HAS_OCCURRED_$$counter, _WRITE_OFFSET_$$counter, _WRITE_VALUE_$$counter, _WRITE_READ_BENIGN_FLAG_$$counter;



implementation {:inline 1} _LOG_WRITE_$$counter(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32)
{
  var track: bool;


  _LOG_WRITE:
    havoc track;
    _WRITE_HAS_OCCURRED_$$counter := (if _P && track then true else _WRITE_HAS_OCCURRED_$$counter);
    _WRITE_OFFSET_$$counter := (if _P && track then _offset else _WRITE_OFFSET_$$counter);
    _WRITE_VALUE_$$counter := (if _P && track then _value else _WRITE_VALUE_$$counter);
    _WRITE_READ_BENIGN_FLAG_$$counter := (if _P && track then _value != _value_old else _WRITE_READ_BENIGN_FLAG_$$counter);
    return;
}



procedure _CHECK_WRITE_$$counter(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "counter"} {:array "$$counter"} {:race} {:write_write} !(_P && _WRITE_HAS_OCCURRED_$$counter && _WRITE_OFFSET_$$counter == _offset && _WRITE_VALUE_$$counter != _value);
  requires {:original_name "counter"} {:array "$$counter"} {:race} {:read_write} !(_P && _READ_HAS_OCCURRED_$$counter && _READ_OFFSET_$$counter == _offset && _READ_VALUE_$$counter != _value);
  requires {:original_name "counter"} {:array "$$counter"} {:race} {:atomic_write} !(_P && _ATOMIC_HAS_OCCURRED_$$counter && _ATOMIC_OFFSET_$$counter == _offset);



procedure {:inline 1} _LOG_ATOMIC_$$counter(_P: bool, _offset: bv32);
  modifies _ATOMIC_HAS_OCCURRED_$$counter, _ATOMIC_OFFSET_$$counter;



implementation {:inline 1} _LOG_ATOMIC_$$counter(_P: bool, _offset: bv32)
{
  var track: bool;


  _LOG_ATOMIC:
    havoc track;
    _ATOMIC_HAS_OCCURRED_$$counter := (if _P && track then true else _ATOMIC_HAS_OCCURRED_$$counter);
    _ATOMIC_OFFSET_$$counter := (if _P && track then _offset else _ATOMIC_OFFSET_$$counter);
    return;
}



procedure _CHECK_ATOMIC_$$counter(_P: bool, _offset: bv32);
  requires {:original_name "counter"} {:array "$$counter"} {:race} {:write_atomic} !(_P && _WRITE_HAS_OCCURRED_$$counter && _WRITE_OFFSET_$$counter == _offset);
  requires {:original_name "counter"} {:array "$$counter"} {:race} {:read_atomic} !(_P && _READ_HAS_OCCURRED_$$counter && _READ_OFFSET_$$counter == _offset);



procedure {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$counter(_P: bool, _offset: bv32);
  modifies _WRITE_READ_BENIGN_FLAG_$$counter;



implementation {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$counter(_P: bool, _offset: bv32)
{

  _UPDATE_BENIGN_FLAG:
    _WRITE_READ_BENIGN_FLAG_$$counter := (if _P && _WRITE_HAS_OCCURRED_$$counter && _WRITE_OFFSET_$$counter == _offset then false else _WRITE_READ_BENIGN_FLAG_$$counter);
    return;
}



function {:bvbuiltin "bvsgt"} BV32_SGT(bv32, bv32) : bool;

function {:bvbuiltin "bvsge"} BV32_SGE(bv32, bv32) : bool;

function {:bvbuiltin "bvslt"} BV32_SLT(bv32, bv32) : bool;
