type _SIZE_T_TYPE = bv32;

procedure _ATOMIC_OP32(y: bv32, x$1: [bv32]bv32, x$2: [bv32]bv32) returns (z$1: bv32, A$1: [bv32]bv32, z$2: bv32, A$2: [bv32]bv32);



var {:original_name "in"} {:global} $$in: [bv32]bv32;

var {:race_checking} {:global} {:elem_width 32} _READ_HAS_OCCURRED_$$in: bool;

var {:race_checking} {:global} {:elem_width 32} _WRITE_HAS_OCCURRED_$$in: bool;

var {:race_checking} {:global} {:elem_width 32} _ATOMIC_HAS_OCCURRED_$$in: bool;

var {:race_checking} {:global} _READ_OFFSET_$$in: bv32;

var {:race_checking} {:global} _WRITE_OFFSET_$$in: bv32;

var {:race_checking} {:global} _ATOMIC_OFFSET_$$in: bv32;

var {:original_name "out"} {:global} $$out: [bv32]bv32;

var {:race_checking} {:global} {:elem_width 32} _READ_HAS_OCCURRED_$$out: bool;

var {:race_checking} {:global} {:elem_width 32} _WRITE_HAS_OCCURRED_$$out: bool;

var {:race_checking} {:global} {:elem_width 32} _ATOMIC_HAS_OCCURRED_$$out: bool;

var {:race_checking} {:global} _READ_OFFSET_$$out: bv32;

var {:race_checking} {:global} _WRITE_OFFSET_$$out: bv32;

var {:race_checking} {:global} _ATOMIC_OFFSET_$$out: bv32;

var {:original_name "lcount"} {:group_shared} $$read_kernel.lcount: [bool][bv32]bv32;

var {:race_checking} {:group_shared} {:elem_width 32} _READ_HAS_OCCURRED_$$read_kernel.lcount: bool;

var {:race_checking} {:group_shared} {:elem_width 32} _WRITE_HAS_OCCURRED_$$read_kernel.lcount: bool;

var {:race_checking} {:group_shared} {:elem_width 32} _ATOMIC_HAS_OCCURRED_$$read_kernel.lcount: bool;

var {:race_checking} {:group_shared} _READ_OFFSET_$$read_kernel.lcount: bv32;

var {:race_checking} {:group_shared} _WRITE_OFFSET_$$read_kernel.lcount: bv32;

var {:race_checking} {:group_shared} _ATOMIC_OFFSET_$$read_kernel.lcount: bv32;

const {:group_id_x} group_id_x$1: bv32;

const {:group_id_x} group_id_x$2: bv32;

const {:group_size_x} group_size_x: bv32;

const {:group_size_y} group_size_y: bv32;

const {:group_size_z} group_size_z: bv32;

const {:local_id_x} local_id_x$1: bv32;

const {:local_id_x} local_id_x$2: bv32;

const {:num_groups_x} num_groups_x: bv32;

const {:num_groups_y} num_groups_y: bv32;

const {:num_groups_z} num_groups_z: bv32;

function {:bvbuiltin "bvadd"} BV32_ADD(bv32, bv32) : bv32;

function {:bvbuiltin "bvmul"} BV32_MUL(bv32, bv32) : bv32;

function {:bvbuiltin "bvudiv"} BV32_UDIV(bv32, bv32) : bv32;

function {:bvbuiltin "bvult"} BV32_ULT(bv32, bv32) : bool;

procedure {:original_name "read_kernel"} {:kernel} $read_kernel($ni: bv32, $val: bv32, $nk: bv32);
  requires !_READ_HAS_OCCURRED_$$in && !_WRITE_HAS_OCCURRED_$$in && !_ATOMIC_HAS_OCCURRED_$$in;
  requires !_READ_HAS_OCCURRED_$$out && !_WRITE_HAS_OCCURRED_$$out && !_ATOMIC_HAS_OCCURRED_$$out;
  requires !_READ_HAS_OCCURRED_$$read_kernel.lcount && !_WRITE_HAS_OCCURRED_$$read_kernel.lcount && !_ATOMIC_HAS_OCCURRED_$$read_kernel.lcount;
  requires BV32_SGT(group_size_x, 0bv32);
  requires BV32_SGT(num_groups_x, 0bv32);
  requires BV32_SGE(group_id_x$1, 0bv32);
  requires BV32_SGE(group_id_x$2, 0bv32);
  requires BV32_SLT(group_id_x$1, num_groups_x);
  requires BV32_SLT(group_id_x$2, num_groups_x);
  requires BV32_SGE(local_id_x$1, 0bv32);
  requires BV32_SGE(local_id_x$2, 0bv32);
  requires BV32_SLT(local_id_x$1, group_size_x);
  requires BV32_SLT(local_id_x$2, group_size_x);
  requires BV32_SGT(group_size_y, 0bv32);
  requires BV32_SGT(num_groups_y, 0bv32);
  requires BV32_SGE(group_id_y$1, 0bv32);
  requires BV32_SGE(group_id_y$2, 0bv32);
  requires BV32_SLT(group_id_y$1, num_groups_y);
  requires BV32_SLT(group_id_y$2, num_groups_y);
  requires BV32_SGE(local_id_y$1, 0bv32);
  requires BV32_SGE(local_id_y$2, 0bv32);
  requires BV32_SLT(local_id_y$1, group_size_y);
  requires BV32_SLT(local_id_y$2, group_size_y);
  requires BV32_SGT(group_size_z, 0bv32);
  requires BV32_SGT(num_groups_z, 0bv32);
  requires BV32_SGE(group_id_z$1, 0bv32);
  requires BV32_SGE(group_id_z$2, 0bv32);
  requires BV32_SLT(group_id_z$1, num_groups_z);
  requires BV32_SLT(group_id_z$2, num_groups_z);
  requires BV32_SGE(local_id_z$1, 0bv32);
  requires BV32_SGE(local_id_z$2, 0bv32);
  requires BV32_SLT(local_id_z$1, group_size_z);
  requires BV32_SLT(local_id_z$2, group_size_z);
  requires group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 ==> local_id_x$1 != local_id_x$2 || local_id_y$1 != local_id_y$2 || local_id_z$1 != local_id_z$2;
  modifies $$read_kernel.lcount, _WRITE_HAS_OCCURRED_$$read_kernel.lcount, _WRITE_OFFSET_$$read_kernel.lcount, _WRITE_VALUE_$$read_kernel.lcount, _WRITE_READ_BENIGN_FLAG_$$read_kernel.lcount, _WRITE_READ_BENIGN_FLAG_$$read_kernel.lcount, $$in, $$out, _ATOMIC_HAS_OCCURRED_$$read_kernel.lcount, _ATOMIC_OFFSET_$$read_kernel.lcount, _READ_HAS_OCCURRED_$$read_kernel.lcount, _READ_OFFSET_$$read_kernel.lcount, _READ_VALUE_$$read_kernel.lcount, _WRITE_HAS_OCCURRED_$$out, _WRITE_OFFSET_$$out, _WRITE_VALUE_$$out, _WRITE_READ_BENIGN_FLAG_$$out, _WRITE_READ_BENIGN_FLAG_$$out, _READ_HAS_OCCURRED_$$in, _READ_OFFSET_$$in, _READ_VALUE_$$in;



implementation {:original_name "read_kernel"} {:kernel} $read_kernel($ni: bv32, $val: bv32, $nk: bv32)
{
  var $pcount.0$1: bv32;
  var $pcount.0$2: bv32;
  var $n.0: bv32;
  var $pcount.1$1: bv32;
  var $pcount.1$2: bv32;
  var $i.0: bv32;
  var $idx.0$1: bv32;
  var $idx.0$2: bv32;
  var $pcount.2$1: bv32;
  var $pcount.2$2: bv32;
  var $pcount.3$1: bv32;
  var $pcount.3$2: bv32;
  var $pcount.4$1: bv32;
  var $pcount.4$2: bv32;
  var $pcount.5$1: bv32;
  var $pcount.5$2: bv32;
  var v0: bool;
  var v1$1: bool;
  var v1$2: bool;
  var v2: bool;
  var v3: bool;
  var v4$1: bv32;
  var v4$2: bv32;
  var v5$1: bv32;
  var v5$2: bv32;
  var v6$1: bv32;
  var v6$2: bv32;
  var v7$1: bv32;
  var v7$2: bv32;
  var v8$1: bool;
  var v8$2: bool;
  var v9$1: bv32;
  var v9$2: bv32;
  var v10$1: bv32;
  var v10$2: bv32;
  var v11$1: bv32;
  var v11$2: bv32;
  var v12$1: bv32;
  var v12$2: bv32;
  var v13$1: bool;
  var v13$2: bool;
  var v14$1: bv32;
  var v14$2: bv32;
  var v15$1: bv32;
  var v15$2: bv32;
  var v16$1: bv32;
  var v16$2: bv32;
  var v17$1: bv32;
  var v17$2: bv32;
  var v18$1: bool;
  var v18$2: bool;
  var v19$1: bv32;
  var v19$2: bv32;
  var v20$1: bv32;
  var v20$2: bv32;
  var v21$1: bv32;
  var v21$2: bv32;
  var v22$1: bv32;
  var v22$2: bv32;
  var v23$1: bool;
  var v23$2: bool;
  var v24$1: bv32;
  var v24$2: bv32;
  var v25$1: bool;
  var v25$2: bool;
  var v26$1: bv32;
  var v26$2: bv32;
  var p0$1: bool;
  var p0$2: bool;
  var p1$1: bool;
  var p1$2: bool;
  var p2$1: bool;
  var p2$2: bool;
  var p3$1: bool;
  var p3$2: bool;
  var p4$1: bool;
  var p4$2: bool;
  var p5$1: bool;
  var p5$2: bool;
  var p6$1: bool;
  var p6$2: bool;
  var p7$1: bool;
  var p7$2: bool;
  var p8$1: bool;
  var p8$2: bool;
  var p9$1: bool;
  var p9$2: bool;
  var p10$1: bool;
  var p10$2: bool;
  var p11$1: bool;
  var p11$2: bool;


  $0:
    v0 := $nk == 0bv32;
    p0$1 := false;
    p0$2 := false;
    p1$1 := false;
    p1$2 := false;
    p10$1 := false;
    p10$2 := false;
    p11$1 := false;
    p11$2 := false;
    goto $truebb, $falsebb;

  $falsebb:
    assume {:partition} !v0 && !v0;
    v1$1 := local_id_x$1 == 0bv32;
    v1$2 := local_id_x$2 == 0bv32;
    p0$1 := v1$1;
    p0$2 := v1$2;
    call {:sourceloc} {:sourceloc_num 0} _LOG_WRITE_$$read_kernel.lcount(p0$1, 0bv32, 0bv32, $$read_kernel.lcount[true][0bv32]);
    call _UPDATE_WRITE_READ_BENIGN_FLAG_$$read_kernel.lcount(p0$2, 0bv32);
    assume {:do_not_predicate} {:check_id "check_state_19"} {:captureState "check_state_19"} {:sourceloc} {:sourceloc_num 0} true;
    call {:check_id "check_state_19"} {:sourceloc} {:sourceloc_num 0} _CHECK_WRITE_$$read_kernel.lcount(p0$2, 0bv32, 0bv32);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_WRITE_$$read_kernel.lcount"} true;
    $$read_kernel.lcount[true][0bv32] := (if p0$1 then 0bv32 else $$read_kernel.lcount[true][0bv32]);
    $$read_kernel.lcount[group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2][0bv32] := (if p0$2 then 0bv32 else $$read_kernel.lcount[group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2][0bv32]);
    call {:sourceloc_num 1} $bugle_barrier_duplicated_0(1bv1, 0bv1);
    $pcount.0$1, $n.0 := 0bv32, 0bv32;
    $pcount.0$2 := 0bv32;
    goto $5;

  $5:
    assume {:captureState "loop_head_state_0"} true;
    v2 := BV32_ULT($n.0, $nk);
    goto $truebb1, $falsebb1;

  $falsebb1:
    assume {:partition} !v2 && !v2;
    call {:sourceloc} {:sourceloc_num 18} {:atomic} {:atomic_function "__atomic_add_local_unsigned_int"} {:arg1 $pcount.0$1} {:parts 1} {:part 1} _LOG_ATOMIC_$$read_kernel.lcount(true, 0bv32);
    assume {:do_not_predicate} {:check_id "check_state_0"} {:captureState "check_state_0"} {:sourceloc} {:sourceloc_num 18} true;
    call {:check_id "check_state_0"} {:sourceloc} {:sourceloc_num 18} {:atomic} {:atomic_function "__atomic_add_local_unsigned_int"} {:arg1 $pcount.0$2} {:parts 1} {:part 1} _CHECK_ATOMIC_$$read_kernel.lcount(true, 0bv32);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_ATOMIC_$$read_kernel.lcount"} true;
    havoc v24$1, v24$2;
    call {:sourceloc_num 19} $bugle_barrier_duplicated_1(1bv1, 0bv1);
    v25$1 := local_id_x$1 == 0bv32;
    v25$2 := local_id_x$2 == 0bv32;
    p10$1 := v25$1;
    p10$2 := v25$2;
    call {:sourceloc} {:sourceloc_num 20} _LOG_READ_$$read_kernel.lcount(p10$1, 0bv32, $$read_kernel.lcount[true][0bv32]);
    assume {:do_not_predicate} {:check_id "check_state_1"} {:captureState "check_state_1"} {:sourceloc} {:sourceloc_num 20} true;
    call {:check_id "check_state_1"} {:sourceloc} {:sourceloc_num 20} _CHECK_READ_$$read_kernel.lcount(p10$2, 0bv32, $$read_kernel.lcount[group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2][0bv32]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$read_kernel.lcount"} true;
    v26$1 := (if p10$1 then $$read_kernel.lcount[true][0bv32] else v26$1);
    v26$2 := (if p10$2 then $$read_kernel.lcount[group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2][0bv32] else v26$2);
    call {:sourceloc} {:sourceloc_num 21} _LOG_WRITE_$$out(p10$1, group_id_x$1, BV32_UDIV(v26$1, $nk), $$out[group_id_x$1]);
    call _UPDATE_WRITE_READ_BENIGN_FLAG_$$out(p10$2, group_id_x$2);
    assume {:do_not_predicate} {:check_id "check_state_2"} {:captureState "check_state_2"} {:sourceloc} {:sourceloc_num 21} true;
    call {:check_id "check_state_2"} {:sourceloc} {:sourceloc_num 21} _CHECK_WRITE_$$out(p10$2, group_id_x$2, BV32_UDIV(v26$2, $nk));
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_WRITE_$$out"} true;
    $$out[group_id_x$1] := (if p10$1 then BV32_UDIV(v26$1, $nk) else $$out[group_id_x$1]);
    $$out[group_id_x$2] := (if p10$2 then BV32_UDIV(v26$2, $nk) else $$out[group_id_x$2]);
    goto $22;

  $22:
    return;

  $truebb1:
    assume {:partition} v2 && v2;
    $pcount.1$1, $i.0, $idx.0$1 := $pcount.0$1, 0bv32, BV32_ADD(BV32_MUL(group_size_x, group_id_x$1), local_id_x$1);
    $pcount.1$2, $idx.0$2 := $pcount.0$2, BV32_ADD(BV32_MUL(group_size_x, group_id_x$2), local_id_x$2);
    goto $7;

  $7:
    assume {:captureState "loop_head_state_1"} true;
    v3 := BV32_ULT($i.0, $ni);
    p2$1 := false;
    p2$2 := false;
    p3$1 := false;
    p3$2 := false;
    p4$1 := false;
    p4$2 := false;
    p5$1 := false;
    p5$2 := false;
    p6$1 := false;
    p6$2 := false;
    p7$1 := false;
    p7$2 := false;
    p8$1 := false;
    p8$2 := false;
    p9$1 := false;
    p9$2 := false;
    goto $truebb2, $falsebb2;

  $falsebb2:
    assume {:partition} !v3 && !v3;
    $pcount.0$1, $n.0 := $pcount.1$1, BV32_ADD($n.0, 1bv32);
    $pcount.0$2 := $pcount.1$2;
    goto $5;

  $truebb2:
    assume {:partition} v3 && v3;
    call {:sourceloc} {:sourceloc_num 2} _LOG_READ_$$in(true, BV32_MUL($idx.0$1, 4bv32), $$in[BV32_MUL($idx.0$1, 4bv32)]);
    assume {:do_not_predicate} {:check_id "check_state_3"} {:captureState "check_state_3"} {:sourceloc} {:sourceloc_num 2} true;
    call {:check_id "check_state_3"} {:sourceloc} {:sourceloc_num 2} _CHECK_READ_$$in(true, BV32_MUL($idx.0$2, 4bv32), $$in[BV32_MUL($idx.0$2, 4bv32)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$in"} true;
    v4$1 := $$in[BV32_MUL($idx.0$1, 4bv32)];
    v4$2 := $$in[BV32_MUL($idx.0$2, 4bv32)];
    call {:sourceloc} {:sourceloc_num 3} _LOG_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 1bv32), $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 1bv32)]);
    assume {:do_not_predicate} {:check_id "check_state_4"} {:captureState "check_state_4"} {:sourceloc} {:sourceloc_num 3} true;
    call {:check_id "check_state_4"} {:sourceloc} {:sourceloc_num 3} _CHECK_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 1bv32), $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 1bv32)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$in"} true;
    v5$1 := $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 1bv32)];
    v5$2 := $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 1bv32)];
    call {:sourceloc} {:sourceloc_num 4} _LOG_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 2bv32), $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 2bv32)]);
    assume {:do_not_predicate} {:check_id "check_state_5"} {:captureState "check_state_5"} {:sourceloc} {:sourceloc_num 4} true;
    call {:check_id "check_state_5"} {:sourceloc} {:sourceloc_num 4} _CHECK_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 2bv32), $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 2bv32)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$in"} true;
    v6$1 := $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 2bv32)];
    v6$2 := $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 2bv32)];
    call {:sourceloc} {:sourceloc_num 5} _LOG_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 3bv32), $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 3bv32)]);
    assume {:do_not_predicate} {:check_id "check_state_6"} {:captureState "check_state_6"} {:sourceloc} {:sourceloc_num 5} true;
    call {:check_id "check_state_6"} {:sourceloc} {:sourceloc_num 5} _CHECK_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 3bv32), $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 3bv32)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$in"} true;
    v7$1 := $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 3bv32)];
    v7$2 := $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 3bv32)];
    v8$1 := v4$1 == $val;
    v8$2 := v4$2 == $val;
    p3$1 := v8$1;
    p3$2 := v8$2;
    p2$1 := !v8$1;
    p2$2 := !v8$2;
    $pcount.2$1 := (if p2$1 then $pcount.1$1 else $pcount.2$1);
    $pcount.2$2 := (if p2$2 then $pcount.1$2 else $pcount.2$2);
    $pcount.2$1 := (if p3$1 then BV32_ADD($pcount.1$1, 1bv32) else $pcount.2$1);
    $pcount.2$2 := (if p3$2 then BV32_ADD($pcount.1$2, 1bv32) else $pcount.2$2);
    call {:sourceloc} {:sourceloc_num 6} _LOG_READ_$$in(true, BV32_MUL($idx.0$1, 4bv32), $$in[BV32_MUL($idx.0$1, 4bv32)]);
    assume {:do_not_predicate} {:check_id "check_state_7"} {:captureState "check_state_7"} {:sourceloc} {:sourceloc_num 6} true;
    call {:check_id "check_state_7"} {:sourceloc} {:sourceloc_num 6} _CHECK_READ_$$in(true, BV32_MUL($idx.0$2, 4bv32), $$in[BV32_MUL($idx.0$2, 4bv32)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$in"} true;
    v9$1 := $$in[BV32_MUL($idx.0$1, 4bv32)];
    v9$2 := $$in[BV32_MUL($idx.0$2, 4bv32)];
    call {:sourceloc} {:sourceloc_num 7} _LOG_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 1bv32), $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 1bv32)]);
    assume {:do_not_predicate} {:check_id "check_state_8"} {:captureState "check_state_8"} {:sourceloc} {:sourceloc_num 7} true;
    call {:check_id "check_state_8"} {:sourceloc} {:sourceloc_num 7} _CHECK_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 1bv32), $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 1bv32)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$in"} true;
    v10$1 := $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 1bv32)];
    v10$2 := $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 1bv32)];
    call {:sourceloc} {:sourceloc_num 8} _LOG_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 2bv32), $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 2bv32)]);
    assume {:do_not_predicate} {:check_id "check_state_9"} {:captureState "check_state_9"} {:sourceloc} {:sourceloc_num 8} true;
    call {:check_id "check_state_9"} {:sourceloc} {:sourceloc_num 8} _CHECK_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 2bv32), $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 2bv32)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$in"} true;
    v11$1 := $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 2bv32)];
    v11$2 := $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 2bv32)];
    call {:sourceloc} {:sourceloc_num 9} _LOG_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 3bv32), $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 3bv32)]);
    assume {:do_not_predicate} {:check_id "check_state_10"} {:captureState "check_state_10"} {:sourceloc} {:sourceloc_num 9} true;
    call {:check_id "check_state_10"} {:sourceloc} {:sourceloc_num 9} _CHECK_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 3bv32), $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 3bv32)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$in"} true;
    v12$1 := $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 3bv32)];
    v12$2 := $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 3bv32)];
    v13$1 := v10$1 == $val;
    v13$2 := v10$2 == $val;
    p5$1 := v13$1;
    p5$2 := v13$2;
    p4$1 := !v13$1;
    p4$2 := !v13$2;
    $pcount.3$1 := (if p4$1 then $pcount.2$1 else $pcount.3$1);
    $pcount.3$2 := (if p4$2 then $pcount.2$2 else $pcount.3$2);
    $pcount.3$1 := (if p5$1 then BV32_ADD($pcount.2$1, 1bv32) else $pcount.3$1);
    $pcount.3$2 := (if p5$2 then BV32_ADD($pcount.2$2, 1bv32) else $pcount.3$2);
    call {:sourceloc} {:sourceloc_num 10} _LOG_READ_$$in(true, BV32_MUL($idx.0$1, 4bv32), $$in[BV32_MUL($idx.0$1, 4bv32)]);
    assume {:do_not_predicate} {:check_id "check_state_11"} {:captureState "check_state_11"} {:sourceloc} {:sourceloc_num 10} true;
    call {:check_id "check_state_11"} {:sourceloc} {:sourceloc_num 10} _CHECK_READ_$$in(true, BV32_MUL($idx.0$2, 4bv32), $$in[BV32_MUL($idx.0$2, 4bv32)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$in"} true;
    v14$1 := $$in[BV32_MUL($idx.0$1, 4bv32)];
    v14$2 := $$in[BV32_MUL($idx.0$2, 4bv32)];
    call {:sourceloc} {:sourceloc_num 11} _LOG_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 1bv32), $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 1bv32)]);
    assume {:do_not_predicate} {:check_id "check_state_12"} {:captureState "check_state_12"} {:sourceloc} {:sourceloc_num 11} true;
    call {:check_id "check_state_12"} {:sourceloc} {:sourceloc_num 11} _CHECK_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 1bv32), $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 1bv32)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$in"} true;
    v15$1 := $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 1bv32)];
    v15$2 := $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 1bv32)];
    call {:sourceloc} {:sourceloc_num 12} _LOG_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 2bv32), $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 2bv32)]);
    assume {:do_not_predicate} {:check_id "check_state_13"} {:captureState "check_state_13"} {:sourceloc} {:sourceloc_num 12} true;
    call {:check_id "check_state_13"} {:sourceloc} {:sourceloc_num 12} _CHECK_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 2bv32), $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 2bv32)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$in"} true;
    v16$1 := $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 2bv32)];
    v16$2 := $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 2bv32)];
    call {:sourceloc} {:sourceloc_num 13} _LOG_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 3bv32), $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 3bv32)]);
    assume {:do_not_predicate} {:check_id "check_state_14"} {:captureState "check_state_14"} {:sourceloc} {:sourceloc_num 13} true;
    call {:check_id "check_state_14"} {:sourceloc} {:sourceloc_num 13} _CHECK_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 3bv32), $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 3bv32)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$in"} true;
    v17$1 := $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 3bv32)];
    v17$2 := $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 3bv32)];
    v18$1 := v16$1 == $val;
    v18$2 := v16$2 == $val;
    p7$1 := v18$1;
    p7$2 := v18$2;
    p6$1 := !v18$1;
    p6$2 := !v18$2;
    $pcount.4$1 := (if p6$1 then $pcount.3$1 else $pcount.4$1);
    $pcount.4$2 := (if p6$2 then $pcount.3$2 else $pcount.4$2);
    $pcount.4$1 := (if p7$1 then BV32_ADD($pcount.3$1, 1bv32) else $pcount.4$1);
    $pcount.4$2 := (if p7$2 then BV32_ADD($pcount.3$2, 1bv32) else $pcount.4$2);
    call {:sourceloc} {:sourceloc_num 14} _LOG_READ_$$in(true, BV32_MUL($idx.0$1, 4bv32), $$in[BV32_MUL($idx.0$1, 4bv32)]);
    assume {:do_not_predicate} {:check_id "check_state_15"} {:captureState "check_state_15"} {:sourceloc} {:sourceloc_num 14} true;
    call {:check_id "check_state_15"} {:sourceloc} {:sourceloc_num 14} _CHECK_READ_$$in(true, BV32_MUL($idx.0$2, 4bv32), $$in[BV32_MUL($idx.0$2, 4bv32)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$in"} true;
    v19$1 := $$in[BV32_MUL($idx.0$1, 4bv32)];
    v19$2 := $$in[BV32_MUL($idx.0$2, 4bv32)];
    call {:sourceloc} {:sourceloc_num 15} _LOG_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 1bv32), $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 1bv32)]);
    assume {:do_not_predicate} {:check_id "check_state_16"} {:captureState "check_state_16"} {:sourceloc} {:sourceloc_num 15} true;
    call {:check_id "check_state_16"} {:sourceloc} {:sourceloc_num 15} _CHECK_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 1bv32), $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 1bv32)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$in"} true;
    v20$1 := $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 1bv32)];
    v20$2 := $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 1bv32)];
    call {:sourceloc} {:sourceloc_num 16} _LOG_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 2bv32), $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 2bv32)]);
    assume {:do_not_predicate} {:check_id "check_state_17"} {:captureState "check_state_17"} {:sourceloc} {:sourceloc_num 16} true;
    call {:check_id "check_state_17"} {:sourceloc} {:sourceloc_num 16} _CHECK_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 2bv32), $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 2bv32)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$in"} true;
    v21$1 := $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 2bv32)];
    v21$2 := $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 2bv32)];
    call {:sourceloc} {:sourceloc_num 17} _LOG_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 3bv32), $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 3bv32)]);
    assume {:do_not_predicate} {:check_id "check_state_18"} {:captureState "check_state_18"} {:sourceloc} {:sourceloc_num 17} true;
    call {:check_id "check_state_18"} {:sourceloc} {:sourceloc_num 17} _CHECK_READ_$$in(true, BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 3bv32), $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 3bv32)]);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$in"} true;
    v22$1 := $$in[BV32_ADD(BV32_MUL($idx.0$1, 4bv32), 3bv32)];
    v22$2 := $$in[BV32_ADD(BV32_MUL($idx.0$2, 4bv32), 3bv32)];
    v23$1 := v22$1 == $val;
    v23$2 := v22$2 == $val;
    p9$1 := v23$1;
    p9$2 := v23$2;
    p8$1 := !v23$1;
    p8$2 := !v23$2;
    $pcount.5$1 := (if p8$1 then $pcount.4$1 else $pcount.5$1);
    $pcount.5$2 := (if p8$2 then $pcount.4$2 else $pcount.5$2);
    $pcount.5$1 := (if p9$1 then BV32_ADD($pcount.4$1, 1bv32) else $pcount.5$1);
    $pcount.5$2 := (if p9$2 then BV32_ADD($pcount.4$2, 1bv32) else $pcount.5$2);
    $pcount.1$1, $i.0, $idx.0$1 := $pcount.5$1, BV32_ADD($i.0, 1bv32), BV32_ADD($idx.0$1, BV32_MUL(group_size_x, num_groups_x));
    $pcount.1$2, $idx.0$2 := $pcount.5$2, BV32_ADD($idx.0$2, BV32_MUL(group_size_x, num_groups_x));
    goto $7;

  $truebb:
    assume {:partition} v0 && v0;
    goto $22;
}



axiom (if group_size_y == 1bv32 then 1bv1 else 0bv1) != 0bv1;

axiom (if group_size_z == 1bv32 then 1bv1 else 0bv1) != 0bv1;

axiom (if num_groups_y == 1bv32 then 1bv1 else 0bv1) != 0bv1;

axiom (if num_groups_z == 1bv32 then 1bv1 else 0bv1) != 0bv1;

axiom (if group_size_x == 128bv32 then 1bv1 else 0bv1) != 0bv1;

axiom (if num_groups_x == 32768bv32 then 1bv1 else 0bv1) != 0bv1;

const {:local_id_y} local_id_y$1: bv32;

const {:local_id_y} local_id_y$2: bv32;

const {:local_id_z} local_id_z$1: bv32;

const {:local_id_z} local_id_z$2: bv32;

const {:group_id_y} group_id_y$1: bv32;

const {:group_id_y} group_id_y$2: bv32;

const {:group_id_z} group_id_z$1: bv32;

const {:group_id_z} group_id_z$2: bv32;

procedure {:inline 1} {:safe_barrier} {:original_name "bugle_barrier"} {:barrier} $bugle_barrier_duplicated_0($0: bv1, $1: bv1);
  modifies $$read_kernel.lcount, $$in, $$out;



procedure {:inline 1} {:safe_barrier} {:original_name "bugle_barrier"} {:barrier} $bugle_barrier_duplicated_1($0: bv1, $1: bv1);
  modifies $$read_kernel.lcount, $$in, $$out;



var _READ_VALUE_$$in: bv32;

procedure {:inline 1} _LOG_READ_$$in(_P: bool, _offset: bv32, _value: bv32);
  modifies _READ_HAS_OCCURRED_$$in, _READ_OFFSET_$$in, _READ_VALUE_$$in;



implementation {:inline 1} _LOG_READ_$$in(_P: bool, _offset: bv32, _value: bv32)
{
  var track: bool;


  _LOG_READ:
    havoc track;
    _READ_HAS_OCCURRED_$$in := (if _P && track then true else _READ_HAS_OCCURRED_$$in);
    _READ_OFFSET_$$in := (if _P && track then _offset else _READ_OFFSET_$$in);
    _READ_VALUE_$$in := (if _P && track then _value else _READ_VALUE_$$in);
    return;
}



procedure _CHECK_READ_$$in(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "in"} {:array "$$in"} {:race} {:write_read} !(_P && _WRITE_HAS_OCCURRED_$$in && _WRITE_OFFSET_$$in == _offset && _WRITE_READ_BENIGN_FLAG_$$in);
  requires {:original_name "in"} {:array "$$in"} {:race} {:atomic_read} !(_P && _ATOMIC_HAS_OCCURRED_$$in && _ATOMIC_OFFSET_$$in == _offset);



var _WRITE_VALUE_$$in: bv32;

var _WRITE_READ_BENIGN_FLAG_$$in: bool;

procedure {:inline 1} _LOG_WRITE_$$in(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32);
  modifies _WRITE_HAS_OCCURRED_$$in, _WRITE_OFFSET_$$in, _WRITE_VALUE_$$in, _WRITE_READ_BENIGN_FLAG_$$in;



implementation {:inline 1} _LOG_WRITE_$$in(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32)
{
  var track: bool;


  _LOG_WRITE:
    havoc track;
    _WRITE_HAS_OCCURRED_$$in := (if _P && track then true else _WRITE_HAS_OCCURRED_$$in);
    _WRITE_OFFSET_$$in := (if _P && track then _offset else _WRITE_OFFSET_$$in);
    _WRITE_VALUE_$$in := (if _P && track then _value else _WRITE_VALUE_$$in);
    _WRITE_READ_BENIGN_FLAG_$$in := (if _P && track then _value != _value_old else _WRITE_READ_BENIGN_FLAG_$$in);
    return;
}



procedure _CHECK_WRITE_$$in(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "in"} {:array "$$in"} {:race} {:write_write} !(_P && _WRITE_HAS_OCCURRED_$$in && _WRITE_OFFSET_$$in == _offset && _WRITE_VALUE_$$in != _value);
  requires {:original_name "in"} {:array "$$in"} {:race} {:read_write} !(_P && _READ_HAS_OCCURRED_$$in && _READ_OFFSET_$$in == _offset && _READ_VALUE_$$in != _value);
  requires {:original_name "in"} {:array "$$in"} {:race} {:atomic_write} !(_P && _ATOMIC_HAS_OCCURRED_$$in && _ATOMIC_OFFSET_$$in == _offset);



procedure {:inline 1} _LOG_ATOMIC_$$in(_P: bool, _offset: bv32);
  modifies _ATOMIC_HAS_OCCURRED_$$in, _ATOMIC_OFFSET_$$in;



implementation {:inline 1} _LOG_ATOMIC_$$in(_P: bool, _offset: bv32)
{
  var track: bool;


  _LOG_ATOMIC:
    havoc track;
    _ATOMIC_HAS_OCCURRED_$$in := (if _P && track then true else _ATOMIC_HAS_OCCURRED_$$in);
    _ATOMIC_OFFSET_$$in := (if _P && track then _offset else _ATOMIC_OFFSET_$$in);
    return;
}



procedure _CHECK_ATOMIC_$$in(_P: bool, _offset: bv32);
  requires {:original_name "in"} {:array "$$in"} {:race} {:write_atomic} !(_P && _WRITE_HAS_OCCURRED_$$in && _WRITE_OFFSET_$$in == _offset);
  requires {:original_name "in"} {:array "$$in"} {:race} {:read_atomic} !(_P && _READ_HAS_OCCURRED_$$in && _READ_OFFSET_$$in == _offset);



procedure {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$in(_P: bool, _offset: bv32);
  modifies _WRITE_READ_BENIGN_FLAG_$$in;



implementation {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$in(_P: bool, _offset: bv32)
{

  _UPDATE_BENIGN_FLAG:
    _WRITE_READ_BENIGN_FLAG_$$in := (if _P && _WRITE_HAS_OCCURRED_$$in && _WRITE_OFFSET_$$in == _offset then false else _WRITE_READ_BENIGN_FLAG_$$in);
    return;
}



var _READ_VALUE_$$out: bv32;

procedure {:inline 1} _LOG_READ_$$out(_P: bool, _offset: bv32, _value: bv32);
  modifies _READ_HAS_OCCURRED_$$out, _READ_OFFSET_$$out, _READ_VALUE_$$out;



implementation {:inline 1} _LOG_READ_$$out(_P: bool, _offset: bv32, _value: bv32)
{
  var track: bool;


  _LOG_READ:
    havoc track;
    _READ_HAS_OCCURRED_$$out := (if _P && track then true else _READ_HAS_OCCURRED_$$out);
    _READ_OFFSET_$$out := (if _P && track then _offset else _READ_OFFSET_$$out);
    _READ_VALUE_$$out := (if _P && track then _value else _READ_VALUE_$$out);
    return;
}



procedure _CHECK_READ_$$out(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "out"} {:array "$$out"} {:race} {:write_read} !(_P && _WRITE_HAS_OCCURRED_$$out && _WRITE_OFFSET_$$out == _offset && _WRITE_READ_BENIGN_FLAG_$$out);
  requires {:original_name "out"} {:array "$$out"} {:race} {:atomic_read} !(_P && _ATOMIC_HAS_OCCURRED_$$out && _ATOMIC_OFFSET_$$out == _offset);



var _WRITE_VALUE_$$out: bv32;

var _WRITE_READ_BENIGN_FLAG_$$out: bool;

procedure {:inline 1} _LOG_WRITE_$$out(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32);
  modifies _WRITE_HAS_OCCURRED_$$out, _WRITE_OFFSET_$$out, _WRITE_VALUE_$$out, _WRITE_READ_BENIGN_FLAG_$$out;



implementation {:inline 1} _LOG_WRITE_$$out(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32)
{
  var track: bool;


  _LOG_WRITE:
    havoc track;
    _WRITE_HAS_OCCURRED_$$out := (if _P && track then true else _WRITE_HAS_OCCURRED_$$out);
    _WRITE_OFFSET_$$out := (if _P && track then _offset else _WRITE_OFFSET_$$out);
    _WRITE_VALUE_$$out := (if _P && track then _value else _WRITE_VALUE_$$out);
    _WRITE_READ_BENIGN_FLAG_$$out := (if _P && track then _value != _value_old else _WRITE_READ_BENIGN_FLAG_$$out);
    return;
}



procedure _CHECK_WRITE_$$out(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "out"} {:array "$$out"} {:race} {:write_write} !(_P && _WRITE_HAS_OCCURRED_$$out && _WRITE_OFFSET_$$out == _offset && _WRITE_VALUE_$$out != _value);
  requires {:original_name "out"} {:array "$$out"} {:race} {:read_write} !(_P && _READ_HAS_OCCURRED_$$out && _READ_OFFSET_$$out == _offset && _READ_VALUE_$$out != _value);
  requires {:original_name "out"} {:array "$$out"} {:race} {:atomic_write} !(_P && _ATOMIC_HAS_OCCURRED_$$out && _ATOMIC_OFFSET_$$out == _offset);



procedure {:inline 1} _LOG_ATOMIC_$$out(_P: bool, _offset: bv32);
  modifies _ATOMIC_HAS_OCCURRED_$$out, _ATOMIC_OFFSET_$$out;



implementation {:inline 1} _LOG_ATOMIC_$$out(_P: bool, _offset: bv32)
{
  var track: bool;


  _LOG_ATOMIC:
    havoc track;
    _ATOMIC_HAS_OCCURRED_$$out := (if _P && track then true else _ATOMIC_HAS_OCCURRED_$$out);
    _ATOMIC_OFFSET_$$out := (if _P && track then _offset else _ATOMIC_OFFSET_$$out);
    return;
}



procedure _CHECK_ATOMIC_$$out(_P: bool, _offset: bv32);
  requires {:original_name "out"} {:array "$$out"} {:race} {:write_atomic} !(_P && _WRITE_HAS_OCCURRED_$$out && _WRITE_OFFSET_$$out == _offset);
  requires {:original_name "out"} {:array "$$out"} {:race} {:read_atomic} !(_P && _READ_HAS_OCCURRED_$$out && _READ_OFFSET_$$out == _offset);



procedure {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$out(_P: bool, _offset: bv32);
  modifies _WRITE_READ_BENIGN_FLAG_$$out;



implementation {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$out(_P: bool, _offset: bv32)
{

  _UPDATE_BENIGN_FLAG:
    _WRITE_READ_BENIGN_FLAG_$$out := (if _P && _WRITE_HAS_OCCURRED_$$out && _WRITE_OFFSET_$$out == _offset then false else _WRITE_READ_BENIGN_FLAG_$$out);
    return;
}



var _READ_VALUE_$$read_kernel.lcount: bv32;

procedure {:inline 1} _LOG_READ_$$read_kernel.lcount(_P: bool, _offset: bv32, _value: bv32);
  modifies _READ_HAS_OCCURRED_$$read_kernel.lcount, _READ_OFFSET_$$read_kernel.lcount, _READ_VALUE_$$read_kernel.lcount;



implementation {:inline 1} _LOG_READ_$$read_kernel.lcount(_P: bool, _offset: bv32, _value: bv32)
{
  var track: bool;


  _LOG_READ:
    havoc track;
    _READ_HAS_OCCURRED_$$read_kernel.lcount := (if _P && track then true else _READ_HAS_OCCURRED_$$read_kernel.lcount);
    _READ_OFFSET_$$read_kernel.lcount := (if _P && track then _offset else _READ_OFFSET_$$read_kernel.lcount);
    _READ_VALUE_$$read_kernel.lcount := (if _P && track then _value else _READ_VALUE_$$read_kernel.lcount);
    return;
}



procedure _CHECK_READ_$$read_kernel.lcount(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "lcount"} {:array "$$read_kernel.lcount"} {:race} {:write_read} !(_P && _WRITE_HAS_OCCURRED_$$read_kernel.lcount && _WRITE_OFFSET_$$read_kernel.lcount == _offset && _WRITE_READ_BENIGN_FLAG_$$read_kernel.lcount && group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2);
  requires {:original_name "lcount"} {:array "$$read_kernel.lcount"} {:race} {:atomic_read} !(_P && _ATOMIC_HAS_OCCURRED_$$read_kernel.lcount && _ATOMIC_OFFSET_$$read_kernel.lcount == _offset && group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2);



var _WRITE_VALUE_$$read_kernel.lcount: bv32;

var _WRITE_READ_BENIGN_FLAG_$$read_kernel.lcount: bool;

procedure {:inline 1} _LOG_WRITE_$$read_kernel.lcount(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32);
  modifies _WRITE_HAS_OCCURRED_$$read_kernel.lcount, _WRITE_OFFSET_$$read_kernel.lcount, _WRITE_VALUE_$$read_kernel.lcount, _WRITE_READ_BENIGN_FLAG_$$read_kernel.lcount;



implementation {:inline 1} _LOG_WRITE_$$read_kernel.lcount(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32)
{
  var track: bool;


  _LOG_WRITE:
    havoc track;
    _WRITE_HAS_OCCURRED_$$read_kernel.lcount := (if _P && track then true else _WRITE_HAS_OCCURRED_$$read_kernel.lcount);
    _WRITE_OFFSET_$$read_kernel.lcount := (if _P && track then _offset else _WRITE_OFFSET_$$read_kernel.lcount);
    _WRITE_VALUE_$$read_kernel.lcount := (if _P && track then _value else _WRITE_VALUE_$$read_kernel.lcount);
    _WRITE_READ_BENIGN_FLAG_$$read_kernel.lcount := (if _P && track then _value != _value_old else _WRITE_READ_BENIGN_FLAG_$$read_kernel.lcount);
    return;
}



procedure _CHECK_WRITE_$$read_kernel.lcount(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "lcount"} {:array "$$read_kernel.lcount"} {:race} {:write_write} !(_P && _WRITE_HAS_OCCURRED_$$read_kernel.lcount && _WRITE_OFFSET_$$read_kernel.lcount == _offset && _WRITE_VALUE_$$read_kernel.lcount != _value && group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2);
  requires {:original_name "lcount"} {:array "$$read_kernel.lcount"} {:race} {:read_write} !(_P && _READ_HAS_OCCURRED_$$read_kernel.lcount && _READ_OFFSET_$$read_kernel.lcount == _offset && _READ_VALUE_$$read_kernel.lcount != _value && group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2);
  requires {:original_name "lcount"} {:array "$$read_kernel.lcount"} {:race} {:atomic_write} !(_P && _ATOMIC_HAS_OCCURRED_$$read_kernel.lcount && _ATOMIC_OFFSET_$$read_kernel.lcount == _offset && group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2);



procedure {:inline 1} _LOG_ATOMIC_$$read_kernel.lcount(_P: bool, _offset: bv32);
  modifies _ATOMIC_HAS_OCCURRED_$$read_kernel.lcount, _ATOMIC_OFFSET_$$read_kernel.lcount;



implementation {:inline 1} _LOG_ATOMIC_$$read_kernel.lcount(_P: bool, _offset: bv32)
{
  var track: bool;


  _LOG_ATOMIC:
    havoc track;
    _ATOMIC_HAS_OCCURRED_$$read_kernel.lcount := (if _P && track then true else _ATOMIC_HAS_OCCURRED_$$read_kernel.lcount);
    _ATOMIC_OFFSET_$$read_kernel.lcount := (if _P && track then _offset else _ATOMIC_OFFSET_$$read_kernel.lcount);
    return;
}



procedure _CHECK_ATOMIC_$$read_kernel.lcount(_P: bool, _offset: bv32);
  requires {:original_name "lcount"} {:array "$$read_kernel.lcount"} {:race} {:write_atomic} !(_P && _WRITE_HAS_OCCURRED_$$read_kernel.lcount && _WRITE_OFFSET_$$read_kernel.lcount == _offset && group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2);
  requires {:original_name "lcount"} {:array "$$read_kernel.lcount"} {:race} {:read_atomic} !(_P && _READ_HAS_OCCURRED_$$read_kernel.lcount && _READ_OFFSET_$$read_kernel.lcount == _offset && group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2);



procedure {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$read_kernel.lcount(_P: bool, _offset: bv32);
  modifies _WRITE_READ_BENIGN_FLAG_$$read_kernel.lcount;



implementation {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$read_kernel.lcount(_P: bool, _offset: bv32)
{

  _UPDATE_BENIGN_FLAG:
    _WRITE_READ_BENIGN_FLAG_$$read_kernel.lcount := (if _P && _WRITE_HAS_OCCURRED_$$read_kernel.lcount && _WRITE_OFFSET_$$read_kernel.lcount == _offset then false else _WRITE_READ_BENIGN_FLAG_$$read_kernel.lcount);
    return;
}



implementation {:inline 1} $bugle_barrier_duplicated_0($0: bv1, $1: bv1)
{

  __BarrierImpl:
    goto anon8_Then, anon8_Else;

  anon8_Else:
    assume {:partition} true;
    goto anon0;

  anon0:
    assume $0 != 0bv1 ==> !_READ_HAS_OCCURRED_$$read_kernel.lcount;
    assume $0 != 0bv1 ==> !_WRITE_HAS_OCCURRED_$$read_kernel.lcount;
    assume $0 != 0bv1 ==> !_ATOMIC_HAS_OCCURRED_$$read_kernel.lcount;
    goto anon1;

  anon1:
    goto anon9_Then, anon9_Else;

  anon9_Else:
    assume {:partition} !($0 != 0bv1 || $0 != 0bv1);
    goto anon3;

  anon3:
    assume group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 ==> $1 != 0bv1 ==> !_READ_HAS_OCCURRED_$$in;
    assume group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 ==> $1 != 0bv1 ==> !_WRITE_HAS_OCCURRED_$$in;
    assume group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 ==> $1 != 0bv1 ==> !_ATOMIC_HAS_OCCURRED_$$in;
    goto anon4;

  anon4:
    assume group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 ==> $1 != 0bv1 ==> !_READ_HAS_OCCURRED_$$out;
    assume group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 ==> $1 != 0bv1 ==> !_WRITE_HAS_OCCURRED_$$out;
    assume group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 ==> $1 != 0bv1 ==> !_ATOMIC_HAS_OCCURRED_$$out;
    goto anon5;

  anon5:
    goto anon10_Then, anon10_Else;

  anon10_Else:
    assume {:partition} !(group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 && ($1 != 0bv1 || $1 != 0bv1));
    return;

  anon10_Then:
    assume {:partition} group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 && ($1 != 0bv1 || $1 != 0bv1);
    havoc $$in;
    goto anon7;

  anon7:
    havoc $$out;
    return;

  anon9_Then:
    assume {:partition} $0 != 0bv1 || $0 != 0bv1;
    havoc $$read_kernel.lcount;
    goto anon3;

  anon8_Then:
    assume {:partition} false;
    goto __Disabled;

  __Disabled:
    return;
}



implementation {:inline 1} $bugle_barrier_duplicated_1($0: bv1, $1: bv1)
{

  __BarrierImpl:
    goto anon8_Then, anon8_Else;

  anon8_Else:
    assume {:partition} true;
    goto anon0;

  anon0:
    assume $0 != 0bv1 ==> !_READ_HAS_OCCURRED_$$read_kernel.lcount;
    assume $0 != 0bv1 ==> !_WRITE_HAS_OCCURRED_$$read_kernel.lcount;
    assume $0 != 0bv1 ==> !_ATOMIC_HAS_OCCURRED_$$read_kernel.lcount;
    goto anon1;

  anon1:
    goto anon9_Then, anon9_Else;

  anon9_Else:
    assume {:partition} !($0 != 0bv1 || $0 != 0bv1);
    goto anon3;

  anon3:
    assume group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 ==> $1 != 0bv1 ==> !_READ_HAS_OCCURRED_$$in;
    assume group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 ==> $1 != 0bv1 ==> !_WRITE_HAS_OCCURRED_$$in;
    assume group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 ==> $1 != 0bv1 ==> !_ATOMIC_HAS_OCCURRED_$$in;
    goto anon4;

  anon4:
    assume group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 ==> $1 != 0bv1 ==> !_READ_HAS_OCCURRED_$$out;
    assume group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 ==> $1 != 0bv1 ==> !_WRITE_HAS_OCCURRED_$$out;
    assume group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 ==> $1 != 0bv1 ==> !_ATOMIC_HAS_OCCURRED_$$out;
    goto anon5;

  anon5:
    goto anon10_Then, anon10_Else;

  anon10_Else:
    assume {:partition} !(group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 && ($1 != 0bv1 || $1 != 0bv1));
    return;

  anon10_Then:
    assume {:partition} group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 && ($1 != 0bv1 || $1 != 0bv1);
    havoc $$in;
    goto anon7;

  anon7:
    havoc $$out;
    return;

  anon9_Then:
    assume {:partition} $0 != 0bv1 || $0 != 0bv1;
    havoc $$read_kernel.lcount;
    goto anon3;

  anon8_Then:
    assume {:partition} false;
    goto __Disabled;

  __Disabled:
    return;
}



function {:bvbuiltin "bvsgt"} BV32_SGT(bv32, bv32) : bool;

function {:bvbuiltin "bvsge"} BV32_SGE(bv32, bv32) : bool;

function {:bvbuiltin "bvslt"} BV32_SLT(bv32, bv32) : bool;
