type _SIZE_T_TYPE = bv32;

procedure _ATOMIC_OP32(x: [bv32]bv32, y: bv32) returns (z$1: bv32, A$1: [bv32]bv32, z$2: bv32, A$2: [bv32]bv32);



var {:original_name "numEigenIntervals"} {:global} $$numEigenIntervals: [bv32]bv32;

var {:race_checking} {:global} {:elem_width 32} _READ_HAS_OCCURRED_$$numEigenIntervals: bool;

var {:race_checking} {:global} {:elem_width 32} _WRITE_HAS_OCCURRED_$$numEigenIntervals: bool;

var {:race_checking} {:global} {:elem_width 32} _ATOMIC_HAS_OCCURRED_$$numEigenIntervals: bool;

var {:race_checking} {:global} _READ_OFFSET_$$numEigenIntervals: bv32;

var {:race_checking} {:global} _WRITE_OFFSET_$$numEigenIntervals: bv32;

var {:race_checking} {:global} _ATOMIC_OFFSET_$$numEigenIntervals: bv32;

var {:race_checking} {:global} {:elem_width 32} _READ_HAS_OCCURRED_$$eigenIntervals: bool;

var {:race_checking} {:global} {:elem_width 32} _WRITE_HAS_OCCURRED_$$eigenIntervals: bool;

var {:race_checking} {:global} {:elem_width 32} _ATOMIC_HAS_OCCURRED_$$eigenIntervals: bool;

var {:race_checking} {:global} _READ_OFFSET_$$eigenIntervals: bv32;

var {:race_checking} {:global} _WRITE_OFFSET_$$eigenIntervals: bv32;

var {:race_checking} {:global} _ATOMIC_OFFSET_$$eigenIntervals: bv32;

var {:race_checking} {:global} {:elem_width 32} _READ_HAS_OCCURRED_$$diagonal: bool;

var {:race_checking} {:global} {:elem_width 32} _WRITE_HAS_OCCURRED_$$diagonal: bool;

var {:race_checking} {:global} {:elem_width 32} _ATOMIC_HAS_OCCURRED_$$diagonal: bool;

var {:race_checking} {:global} _READ_OFFSET_$$diagonal: bv32;

var {:race_checking} {:global} _WRITE_OFFSET_$$diagonal: bv32;

var {:race_checking} {:global} _ATOMIC_OFFSET_$$diagonal: bv32;

var {:race_checking} {:global} {:elem_width 32} _READ_HAS_OCCURRED_$$offDiagonal: bool;

var {:race_checking} {:global} {:elem_width 32} _WRITE_HAS_OCCURRED_$$offDiagonal: bool;

var {:race_checking} {:global} {:elem_width 32} _ATOMIC_HAS_OCCURRED_$$offDiagonal: bool;

var {:race_checking} {:global} _READ_OFFSET_$$offDiagonal: bv32;

var {:race_checking} {:global} _WRITE_OFFSET_$$offDiagonal: bv32;

var {:race_checking} {:global} _ATOMIC_OFFSET_$$offDiagonal: bv32;

const {:group_id_x} group_id_x$1: bv32;

const {:group_id_x} group_id_x$2: bv32;

const {:group_size_x} group_size_x: bv32;

const {:group_size_y} group_size_y: bv32;

const {:group_size_z} group_size_z: bv32;

const {:local_id_x} local_id_x$1: bv32;

const {:local_id_x} local_id_x$2: bv32;

const {:num_groups_x} num_groups_x: bv32;

const {:num_groups_y} num_groups_y: bv32;

const {:num_groups_z} num_groups_z: bv32;

function FDIV32(bv32, bv32) : bv32;

function FLT32(bv32, bv32) : bool;

function FMUL32(bv32, bv32) : bv32;

function FP32_TO_UI32(bv32) : bv32;

function FSUB32(bv32, bv32) : bv32;

function UI32_TO_FP32(bv32) : bv32;

function {:bvbuiltin "bvadd"} BV32_ADD(bv32, bv32) : bv32;

function {:bvbuiltin "bvmul"} BV32_MUL(bv32, bv32) : bv32;

function {:bvbuiltin "bvsub"} BV32_SUB(bv32, bv32) : bv32;

function {:bvbuiltin "bvult"} BV32_ULT(bv32, bv32) : bool;

procedure {:original_name "calNumEigenValueInterval"} {:kernel} $calNumEigenValueInterval($width: bv32);
  requires !_READ_HAS_OCCURRED_$$numEigenIntervals && !_WRITE_HAS_OCCURRED_$$numEigenIntervals && !_ATOMIC_HAS_OCCURRED_$$numEigenIntervals;
  requires !_READ_HAS_OCCURRED_$$eigenIntervals && !_WRITE_HAS_OCCURRED_$$eigenIntervals && !_ATOMIC_HAS_OCCURRED_$$eigenIntervals;
  requires !_READ_HAS_OCCURRED_$$diagonal && !_WRITE_HAS_OCCURRED_$$diagonal && !_ATOMIC_HAS_OCCURRED_$$diagonal;
  requires !_READ_HAS_OCCURRED_$$offDiagonal && !_WRITE_HAS_OCCURRED_$$offDiagonal && !_ATOMIC_HAS_OCCURRED_$$offDiagonal;
  requires BV32_SGT(group_size_x, 0bv32);
  requires BV32_SGT(num_groups_x, 0bv32);
  requires BV32_SGE(group_id_x$1, 0bv32);
  requires BV32_SGE(group_id_x$2, 0bv32);
  requires BV32_SLT(group_id_x$1, num_groups_x);
  requires BV32_SLT(group_id_x$2, num_groups_x);
  requires BV32_SGE(local_id_x$1, 0bv32);
  requires BV32_SGE(local_id_x$2, 0bv32);
  requires BV32_SLT(local_id_x$1, group_size_x);
  requires BV32_SLT(local_id_x$2, group_size_x);
  requires BV32_SGT(group_size_y, 0bv32);
  requires BV32_SGT(num_groups_y, 0bv32);
  requires BV32_SGE(group_id_y$1, 0bv32);
  requires BV32_SGE(group_id_y$2, 0bv32);
  requires BV32_SLT(group_id_y$1, num_groups_y);
  requires BV32_SLT(group_id_y$2, num_groups_y);
  requires BV32_SGE(local_id_y$1, 0bv32);
  requires BV32_SGE(local_id_y$2, 0bv32);
  requires BV32_SLT(local_id_y$1, group_size_y);
  requires BV32_SLT(local_id_y$2, group_size_y);
  requires BV32_SGT(group_size_z, 0bv32);
  requires BV32_SGT(num_groups_z, 0bv32);
  requires BV32_SGE(group_id_z$1, 0bv32);
  requires BV32_SGE(group_id_z$2, 0bv32);
  requires BV32_SLT(group_id_z$1, num_groups_z);
  requires BV32_SLT(group_id_z$2, num_groups_z);
  requires BV32_SGE(local_id_z$1, 0bv32);
  requires BV32_SGE(local_id_z$2, 0bv32);
  requires BV32_SLT(local_id_z$1, group_size_z);
  requires BV32_SLT(local_id_z$2, group_size_z);
  requires group_id_x$1 == group_id_x$2 && group_id_y$1 == group_id_y$2 && group_id_z$1 == group_id_z$2 ==> local_id_x$1 != local_id_x$2 || local_id_y$1 != local_id_y$2 || local_id_z$1 != local_id_z$2;
  modifies _READ_HAS_OCCURRED_$$eigenIntervals, _READ_OFFSET_$$eigenIntervals, _READ_VALUE_$$eigenIntervals, _READ_HAS_OCCURRED_$$diagonal, _READ_OFFSET_$$diagonal, _READ_VALUE_$$diagonal, _WRITE_HAS_OCCURRED_$$numEigenIntervals, _WRITE_OFFSET_$$numEigenIntervals, _WRITE_VALUE_$$numEigenIntervals, _WRITE_READ_BENIGN_FLAG_$$numEigenIntervals, _WRITE_READ_BENIGN_FLAG_$$numEigenIntervals, _READ_HAS_OCCURRED_$$offDiagonal, _READ_OFFSET_$$offDiagonal, _READ_VALUE_$$offDiagonal;



implementation {:original_name "calNumEigenValueInterval"} {:kernel} $calNumEigenValueInterval($width: bv32)
{
  var $count.i.0$1: bv32;
  var $count.i.0$2: bv32;
  var $prev_diff.i.0$1: bv32;
  var $prev_diff.i.0$2: bv32;
  var $i.i.0: bv32;
  var $prev_diff.i2.0$1: bv32;
  var $prev_diff.i2.0$2: bv32;
  var $count.i1.0$1: bv32;
  var $count.i1.0$2: bv32;
  var $i.i3.0: bv32;
  var v0$1: bv32;
  var v0$2: bv32;
  var v1$1: bv32;
  var v1$2: bv32;
  var v2$1: bv32;
  var v2$2: bv32;
  var v3$1: bv32;
  var v3$2: bv32;
  var v4$1: bv32;
  var v4$2: bv32;
  var v5$1: bv32;
  var v5$2: bv32;
  var v6: bool;
  var v7$1: bv32;
  var v7$2: bv32;
  var v8$1: bv32;
  var v8$2: bv32;
  var v9$1: bv32;
  var v9$2: bv32;
  var v10$1: bv32;
  var v10$2: bv32;
  var v12$1: bv32;
  var v12$2: bv32;
  var v11$1: bv32;
  var v11$2: bv32;
  var v14$1: bv32;
  var v14$2: bv32;
  var v13: bool;
  var v15$1: bv32;
  var v15$2: bv32;
  var v16$1: bv32;
  var v16$2: bv32;
  var v17$1: bv32;
  var v17$2: bv32;
  var _abstracted_call_arg_0$1: bv32;
  var _abstracted_call_arg_0$2: bv32;
  var _abstracted_call_arg_1$1: bv32;
  var _abstracted_call_arg_1$2: bv32;
  var _abstracted_call_arg_2$1: bv32;
  var _abstracted_call_arg_2$2: bv32;
  var _abstracted_call_arg_3$1: bv32;
  var _abstracted_call_arg_3$2: bv32;
  var _abstracted_call_arg_4$1: bv32;
  var _abstracted_call_arg_4$2: bv32;
  var _abstracted_call_arg_5$1: bv32;
  var _abstracted_call_arg_5$2: bv32;
  var _abstracted_call_arg_6$1: bv32;
  var _abstracted_call_arg_6$2: bv32;
  var _abstracted_call_arg_7$1: bv32;
  var _abstracted_call_arg_7$2: bv32;
  var _abstracted_call_arg_8$1: bv32;
  var _abstracted_call_arg_8$2: bv32;
  var _abstracted_call_arg_9$1: bv32;
  var _abstracted_call_arg_9$2: bv32;
  var _abstracted_call_arg_10$1: bv32;
  var _abstracted_call_arg_10$2: bv32;
  var _abstracted_call_arg_11$1: bv32;
  var _abstracted_call_arg_11$2: bv32;
  var _abstracted_call_arg_12$1: bv32;
  var _abstracted_call_arg_12$2: bv32;
  var _abstracted_call_arg_13$1: bv32;
  var _abstracted_call_arg_13$2: bv32;
  var _abstracted_call_arg_14$1: bv32;
  var _abstracted_call_arg_14$2: bv32;
  var _abstracted_call_arg_15$1: bv32;
  var _abstracted_call_arg_15$2: bv32;
  var _abstracted_call_arg_16$1: bv32;
  var _abstracted_call_arg_16$2: bv32;
  var _abstracted_call_arg_17$1: bv32;
  var _abstracted_call_arg_17$2: bv32;
  var _abstracted_call_arg_18$1: bv32;
  var _abstracted_call_arg_18$2: bv32;
  var _abstracted_call_arg_19$1: bv32;
  var _abstracted_call_arg_19$2: bv32;


  $0:
    v0$1 := BV32_ADD(BV32_MUL(group_size_x, group_id_x$1), local_id_x$1);
    v0$2 := BV32_ADD(BV32_MUL(group_size_x, group_id_x$2), local_id_x$2);
    v1$1 := BV32_MUL(2bv32, v0$1);
    v1$2 := BV32_MUL(2bv32, v0$2);
    havoc _abstracted_call_arg_0$1, _abstracted_call_arg_0$2;
    call {:sourceloc} {:sourceloc_num 0} _LOG_READ_$$eigenIntervals(true, v1$1, _abstracted_call_arg_0$1);
    assume {:do_not_predicate} {:check_id "check_state_0"} {:captureState "check_state_0"} {:sourceloc} {:sourceloc_num 0} true;
    havoc _abstracted_call_arg_1$1, _abstracted_call_arg_1$2;
    call {:check_id "check_state_0"} {:sourceloc} {:sourceloc_num 0} _CHECK_READ_$$eigenIntervals(true, v1$2, _abstracted_call_arg_1$2);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$eigenIntervals"} true;
    havoc v2$1, v2$2;
    havoc _abstracted_call_arg_2$1, _abstracted_call_arg_2$2;
    call {:sourceloc} {:sourceloc_num 1} _LOG_READ_$$eigenIntervals(true, BV32_ADD(v1$1, 1bv32), _abstracted_call_arg_2$1);
    assume {:do_not_predicate} {:check_id "check_state_1"} {:captureState "check_state_1"} {:sourceloc} {:sourceloc_num 1} true;
    havoc _abstracted_call_arg_3$1, _abstracted_call_arg_3$2;
    call {:check_id "check_state_1"} {:sourceloc} {:sourceloc_num 1} _CHECK_READ_$$eigenIntervals(true, BV32_ADD(v1$2, 1bv32), _abstracted_call_arg_3$2);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$eigenIntervals"} true;
    havoc v3$1, v3$2;
    havoc _abstracted_call_arg_4$1, _abstracted_call_arg_4$2;
    call {:sourceloc} {:sourceloc_num 2} _LOG_READ_$$diagonal(true, 0bv32, _abstracted_call_arg_4$1);
    assume {:do_not_predicate} {:check_id "check_state_2"} {:captureState "check_state_2"} {:sourceloc} {:sourceloc_num 2} true;
    havoc _abstracted_call_arg_5$1, _abstracted_call_arg_5$2;
    call {:check_id "check_state_2"} {:sourceloc} {:sourceloc_num 2} _CHECK_READ_$$diagonal(true, 0bv32, _abstracted_call_arg_5$2);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$diagonal"} true;
    havoc v4$1, v4$2;
    v5$1 := FSUB32(v4$1, v2$1);
    v5$2 := FSUB32(v4$2, v2$2);
    $count.i.0$1, $prev_diff.i.0$1, $i.i.0 := (if FLT32(v5$1, 0bv32) then 1bv32 else 0bv32), v5$1, 1bv32;
    $count.i.0$2, $prev_diff.i.0$2 := (if FLT32(v5$2, 0bv32) then 1bv32 else 0bv32), v5$2;
    goto $1;

  $1:
    assume {:captureState "loop_head_state_1"} true;
    v6 := BV32_ULT($i.i.0, $width);
    goto $truebb, $falsebb;

  $falsebb:
    assume {:partition} !v6 && !v6;
    havoc _abstracted_call_arg_6$1, _abstracted_call_arg_6$2;
    call {:sourceloc} {:sourceloc_num 6} _LOG_READ_$$diagonal(true, 0bv32, _abstracted_call_arg_6$1);
    assume {:do_not_predicate} {:check_id "check_state_3"} {:captureState "check_state_3"} {:sourceloc} {:sourceloc_num 6} true;
    havoc _abstracted_call_arg_7$1, _abstracted_call_arg_7$2;
    call {:check_id "check_state_3"} {:sourceloc} {:sourceloc_num 6} _CHECK_READ_$$diagonal(true, 0bv32, _abstracted_call_arg_7$2);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$diagonal"} true;
    havoc v11$1, v11$2;
    v12$1 := FSUB32(v11$1, v3$1);
    v12$2 := FSUB32(v11$2, v3$2);
    $prev_diff.i2.0$1, $count.i1.0$1, $i.i3.0 := v12$1, (if FLT32(v12$1, 0bv32) then 1bv32 else 0bv32), 1bv32;
    $prev_diff.i2.0$2, $count.i1.0$2 := v12$2, (if FLT32(v12$2, 0bv32) then 1bv32 else 0bv32);
    goto $3;

  $3:
    assume {:captureState "loop_head_state_0"} true;
    v13 := BV32_ULT($i.i3.0, $width);
    goto $truebb0, $falsebb0;

  $falsebb0:
    assume {:partition} !v13 && !v13;
    call {:sourceloc} {:sourceloc_num 10} _LOG_WRITE_$$numEigenIntervals(true, v0$1, BV32_SUB(FP32_TO_UI32(UI32_TO_FP32($count.i1.0$1)), FP32_TO_UI32(UI32_TO_FP32($count.i.0$1))), $$numEigenIntervals[v0$1]);
    call _UPDATE_WRITE_READ_BENIGN_FLAG_$$numEigenIntervals(true, v0$2);
    assume {:do_not_predicate} {:check_id "check_state_4"} {:captureState "check_state_4"} {:sourceloc} {:sourceloc_num 10} true;
    call {:check_id "check_state_4"} {:sourceloc} {:sourceloc_num 10} _CHECK_WRITE_$$numEigenIntervals(true, v0$2, BV32_SUB(FP32_TO_UI32(UI32_TO_FP32($count.i1.0$2)), FP32_TO_UI32(UI32_TO_FP32($count.i.0$2))));
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_WRITE_$$numEigenIntervals"} true;
    $$numEigenIntervals[v0$1] := BV32_SUB(FP32_TO_UI32(UI32_TO_FP32($count.i1.0$1)), FP32_TO_UI32(UI32_TO_FP32($count.i.0$1)));
    $$numEigenIntervals[v0$2] := BV32_SUB(FP32_TO_UI32(UI32_TO_FP32($count.i1.0$2)), FP32_TO_UI32(UI32_TO_FP32($count.i.0$2)));
    return;

  $truebb0:
    assume {:partition} v13 && v13;
    havoc _abstracted_call_arg_8$1, _abstracted_call_arg_8$2;
    call {:sourceloc} {:sourceloc_num 7} _LOG_READ_$$diagonal(true, $i.i3.0, _abstracted_call_arg_8$1);
    assume {:do_not_predicate} {:check_id "check_state_5"} {:captureState "check_state_5"} {:sourceloc} {:sourceloc_num 7} true;
    havoc _abstracted_call_arg_9$1, _abstracted_call_arg_9$2;
    call {:check_id "check_state_5"} {:sourceloc} {:sourceloc_num 7} _CHECK_READ_$$diagonal(true, $i.i3.0, _abstracted_call_arg_9$2);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$diagonal"} true;
    havoc v14$1, v14$2;
    havoc _abstracted_call_arg_10$1, _abstracted_call_arg_10$2;
    call {:sourceloc} {:sourceloc_num 8} _LOG_READ_$$offDiagonal(true, BV32_SUB($i.i3.0, 1bv32), _abstracted_call_arg_10$1);
    assume {:do_not_predicate} {:check_id "check_state_6"} {:captureState "check_state_6"} {:sourceloc} {:sourceloc_num 8} true;
    havoc _abstracted_call_arg_11$1, _abstracted_call_arg_11$2;
    call {:check_id "check_state_6"} {:sourceloc} {:sourceloc_num 8} _CHECK_READ_$$offDiagonal(true, BV32_SUB($i.i3.0, 1bv32), _abstracted_call_arg_11$2);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$offDiagonal"} true;
    havoc v15$1, v15$2;
    havoc _abstracted_call_arg_12$1, _abstracted_call_arg_12$2;
    call {:sourceloc} {:sourceloc_num 9} _LOG_READ_$$offDiagonal(true, BV32_SUB($i.i3.0, 1bv32), _abstracted_call_arg_12$1);
    assume {:do_not_predicate} {:check_id "check_state_7"} {:captureState "check_state_7"} {:sourceloc} {:sourceloc_num 9} true;
    havoc _abstracted_call_arg_13$1, _abstracted_call_arg_13$2;
    call {:check_id "check_state_7"} {:sourceloc} {:sourceloc_num 9} _CHECK_READ_$$offDiagonal(true, BV32_SUB($i.i3.0, 1bv32), _abstracted_call_arg_13$2);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$offDiagonal"} true;
    havoc v16$1, v16$2;
    v17$1 := FSUB32(FSUB32(v14$1, v3$1), FDIV32(FMUL32(v15$1, v16$1), $prev_diff.i2.0$1));
    v17$2 := FSUB32(FSUB32(v14$2, v3$2), FDIV32(FMUL32(v15$2, v16$2), $prev_diff.i2.0$2));
    $prev_diff.i2.0$1, $count.i1.0$1, $i.i3.0 := v17$1, BV32_ADD($count.i1.0$1, (if FLT32(v17$1, 0bv32) then 1bv32 else 0bv32)), BV32_ADD($i.i3.0, 1bv32);
    $prev_diff.i2.0$2, $count.i1.0$2 := v17$2, BV32_ADD($count.i1.0$2, (if FLT32(v17$2, 0bv32) then 1bv32 else 0bv32));
    goto $3;

  $truebb:
    assume {:partition} v6 && v6;
    havoc _abstracted_call_arg_14$1, _abstracted_call_arg_14$2;
    call {:sourceloc} {:sourceloc_num 3} _LOG_READ_$$diagonal(true, $i.i.0, _abstracted_call_arg_14$1);
    assume {:do_not_predicate} {:check_id "check_state_8"} {:captureState "check_state_8"} {:sourceloc} {:sourceloc_num 3} true;
    havoc _abstracted_call_arg_15$1, _abstracted_call_arg_15$2;
    call {:check_id "check_state_8"} {:sourceloc} {:sourceloc_num 3} _CHECK_READ_$$diagonal(true, $i.i.0, _abstracted_call_arg_15$2);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$diagonal"} true;
    havoc v7$1, v7$2;
    havoc _abstracted_call_arg_16$1, _abstracted_call_arg_16$2;
    call {:sourceloc} {:sourceloc_num 4} _LOG_READ_$$offDiagonal(true, BV32_SUB($i.i.0, 1bv32), _abstracted_call_arg_16$1);
    assume {:do_not_predicate} {:check_id "check_state_9"} {:captureState "check_state_9"} {:sourceloc} {:sourceloc_num 4} true;
    havoc _abstracted_call_arg_17$1, _abstracted_call_arg_17$2;
    call {:check_id "check_state_9"} {:sourceloc} {:sourceloc_num 4} _CHECK_READ_$$offDiagonal(true, BV32_SUB($i.i.0, 1bv32), _abstracted_call_arg_17$2);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$offDiagonal"} true;
    havoc v8$1, v8$2;
    havoc _abstracted_call_arg_18$1, _abstracted_call_arg_18$2;
    call {:sourceloc} {:sourceloc_num 5} _LOG_READ_$$offDiagonal(true, BV32_SUB($i.i.0, 1bv32), _abstracted_call_arg_18$1);
    assume {:do_not_predicate} {:check_id "check_state_10"} {:captureState "check_state_10"} {:sourceloc} {:sourceloc_num 5} true;
    havoc _abstracted_call_arg_19$1, _abstracted_call_arg_19$2;
    call {:check_id "check_state_10"} {:sourceloc} {:sourceloc_num 5} _CHECK_READ_$$offDiagonal(true, BV32_SUB($i.i.0, 1bv32), _abstracted_call_arg_19$2);
    assume {:captureState "call_return_state_0"} {:procedureName "_CHECK_READ_$$offDiagonal"} true;
    havoc v9$1, v9$2;
    v10$1 := FSUB32(FSUB32(v7$1, v2$1), FDIV32(FMUL32(v8$1, v9$1), $prev_diff.i.0$1));
    v10$2 := FSUB32(FSUB32(v7$2, v2$2), FDIV32(FMUL32(v8$2, v9$2), $prev_diff.i.0$2));
    $count.i.0$1, $prev_diff.i.0$1, $i.i.0 := BV32_ADD($count.i.0$1, (if FLT32(v10$1, 0bv32) then 1bv32 else 0bv32)), v10$1, BV32_ADD($i.i.0, 1bv32);
    $count.i.0$2, $prev_diff.i.0$2 := BV32_ADD($count.i.0$2, (if FLT32(v10$2, 0bv32) then 1bv32 else 0bv32)), v10$2;
    goto $1;
}



axiom (if group_size_y == 1bv32 then 1bv1 else 0bv1) != 0bv1;

axiom (if group_size_z == 1bv32 then 1bv1 else 0bv1) != 0bv1;

axiom (if num_groups_y == 1bv32 then 1bv1 else 0bv1) != 0bv1;

axiom (if num_groups_z == 1bv32 then 1bv1 else 0bv1) != 0bv1;

axiom (if group_size_x == 256bv32 then 1bv1 else 0bv1) != 0bv1;

axiom (if num_groups_x == 4bv32 then 1bv1 else 0bv1) != 0bv1;

const {:local_id_y} local_id_y$1: bv32;

const {:local_id_y} local_id_y$2: bv32;

const {:local_id_z} local_id_z$1: bv32;

const {:local_id_z} local_id_z$2: bv32;

const {:group_id_y} group_id_y$1: bv32;

const {:group_id_y} group_id_y$2: bv32;

const {:group_id_z} group_id_z$1: bv32;

const {:group_id_z} group_id_z$2: bv32;

var _READ_VALUE_$$numEigenIntervals: bv32;

procedure {:inline 1} _LOG_READ_$$numEigenIntervals(_P: bool, _offset: bv32, _value: bv32);
  modifies _READ_HAS_OCCURRED_$$numEigenIntervals, _READ_OFFSET_$$numEigenIntervals, _READ_VALUE_$$numEigenIntervals;



implementation {:inline 1} _LOG_READ_$$numEigenIntervals(_P: bool, _offset: bv32, _value: bv32)
{
  var track: bool;


  _LOG_READ:
    havoc track;
    _READ_HAS_OCCURRED_$$numEigenIntervals := (if _P && track then true else _READ_HAS_OCCURRED_$$numEigenIntervals);
    _READ_OFFSET_$$numEigenIntervals := (if _P && track then _offset else _READ_OFFSET_$$numEigenIntervals);
    _READ_VALUE_$$numEigenIntervals := (if _P && track then _value else _READ_VALUE_$$numEigenIntervals);
    return;
}



procedure _CHECK_READ_$$numEigenIntervals(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "numEigenIntervals"} {:array "$$numEigenIntervals"} {:race} {:write_read} !(_P && _WRITE_HAS_OCCURRED_$$numEigenIntervals && _WRITE_OFFSET_$$numEigenIntervals == _offset && _WRITE_READ_BENIGN_FLAG_$$numEigenIntervals);
  requires {:original_name "numEigenIntervals"} {:array "$$numEigenIntervals"} {:race} {:atomic_read} !(_P && _ATOMIC_HAS_OCCURRED_$$numEigenIntervals && _ATOMIC_OFFSET_$$numEigenIntervals == _offset);



var _WRITE_VALUE_$$numEigenIntervals: bv32;

var _WRITE_READ_BENIGN_FLAG_$$numEigenIntervals: bool;

procedure {:inline 1} _LOG_WRITE_$$numEigenIntervals(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32);
  modifies _WRITE_HAS_OCCURRED_$$numEigenIntervals, _WRITE_OFFSET_$$numEigenIntervals, _WRITE_VALUE_$$numEigenIntervals, _WRITE_READ_BENIGN_FLAG_$$numEigenIntervals;



implementation {:inline 1} _LOG_WRITE_$$numEigenIntervals(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32)
{
  var track: bool;


  _LOG_WRITE:
    havoc track;
    _WRITE_HAS_OCCURRED_$$numEigenIntervals := (if _P && track then true else _WRITE_HAS_OCCURRED_$$numEigenIntervals);
    _WRITE_OFFSET_$$numEigenIntervals := (if _P && track then _offset else _WRITE_OFFSET_$$numEigenIntervals);
    _WRITE_VALUE_$$numEigenIntervals := (if _P && track then _value else _WRITE_VALUE_$$numEigenIntervals);
    _WRITE_READ_BENIGN_FLAG_$$numEigenIntervals := (if _P && track then _value != _value_old else _WRITE_READ_BENIGN_FLAG_$$numEigenIntervals);
    return;
}



procedure _CHECK_WRITE_$$numEigenIntervals(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "numEigenIntervals"} {:array "$$numEigenIntervals"} {:race} {:write_write} !(_P && _WRITE_HAS_OCCURRED_$$numEigenIntervals && _WRITE_OFFSET_$$numEigenIntervals == _offset && _WRITE_VALUE_$$numEigenIntervals != _value);
  requires {:original_name "numEigenIntervals"} {:array "$$numEigenIntervals"} {:race} {:read_write} !(_P && _READ_HAS_OCCURRED_$$numEigenIntervals && _READ_OFFSET_$$numEigenIntervals == _offset && _READ_VALUE_$$numEigenIntervals != _value);
  requires {:original_name "numEigenIntervals"} {:array "$$numEigenIntervals"} {:race} {:atomic_write} !(_P && _ATOMIC_HAS_OCCURRED_$$numEigenIntervals && _ATOMIC_OFFSET_$$numEigenIntervals == _offset);



procedure {:inline 1} _LOG_ATOMIC_$$numEigenIntervals(_P: bool, _offset: bv32);
  modifies _ATOMIC_HAS_OCCURRED_$$numEigenIntervals, _ATOMIC_OFFSET_$$numEigenIntervals;



implementation {:inline 1} _LOG_ATOMIC_$$numEigenIntervals(_P: bool, _offset: bv32)
{
  var track: bool;


  _LOG_ATOMIC:
    havoc track;
    _ATOMIC_HAS_OCCURRED_$$numEigenIntervals := (if _P && track then true else _ATOMIC_HAS_OCCURRED_$$numEigenIntervals);
    _ATOMIC_OFFSET_$$numEigenIntervals := (if _P && track then _offset else _ATOMIC_OFFSET_$$numEigenIntervals);
    return;
}



procedure _CHECK_ATOMIC_$$numEigenIntervals(_P: bool, _offset: bv32);
  requires {:original_name "numEigenIntervals"} {:array "$$numEigenIntervals"} {:race} {:write_atomic} !(_P && _WRITE_HAS_OCCURRED_$$numEigenIntervals && _WRITE_OFFSET_$$numEigenIntervals == _offset);
  requires {:original_name "numEigenIntervals"} {:array "$$numEigenIntervals"} {:race} {:read_atomic} !(_P && _READ_HAS_OCCURRED_$$numEigenIntervals && _READ_OFFSET_$$numEigenIntervals == _offset);



procedure {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$numEigenIntervals(_P: bool, _offset: bv32);
  modifies _WRITE_READ_BENIGN_FLAG_$$numEigenIntervals;



implementation {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$numEigenIntervals(_P: bool, _offset: bv32)
{

  _UPDATE_BENIGN_FLAG:
    _WRITE_READ_BENIGN_FLAG_$$numEigenIntervals := (if _P && _WRITE_HAS_OCCURRED_$$numEigenIntervals && _WRITE_OFFSET_$$numEigenIntervals == _offset then false else _WRITE_READ_BENIGN_FLAG_$$numEigenIntervals);
    return;
}



var _READ_VALUE_$$eigenIntervals: bv32;

procedure {:inline 1} _LOG_READ_$$eigenIntervals(_P: bool, _offset: bv32, _value: bv32);
  modifies _READ_HAS_OCCURRED_$$eigenIntervals, _READ_OFFSET_$$eigenIntervals, _READ_VALUE_$$eigenIntervals;



implementation {:inline 1} _LOG_READ_$$eigenIntervals(_P: bool, _offset: bv32, _value: bv32)
{
  var track: bool;


  _LOG_READ:
    havoc track;
    _READ_HAS_OCCURRED_$$eigenIntervals := (if _P && track then true else _READ_HAS_OCCURRED_$$eigenIntervals);
    _READ_OFFSET_$$eigenIntervals := (if _P && track then _offset else _READ_OFFSET_$$eigenIntervals);
    _READ_VALUE_$$eigenIntervals := (if _P && track then _value else _READ_VALUE_$$eigenIntervals);
    return;
}



procedure _CHECK_READ_$$eigenIntervals(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "eigenIntervals"} {:array "$$eigenIntervals"} {:race} {:write_read} !(_P && _WRITE_HAS_OCCURRED_$$eigenIntervals && _WRITE_OFFSET_$$eigenIntervals == _offset && _WRITE_READ_BENIGN_FLAG_$$eigenIntervals);
  requires {:original_name "eigenIntervals"} {:array "$$eigenIntervals"} {:race} {:atomic_read} !(_P && _ATOMIC_HAS_OCCURRED_$$eigenIntervals && _ATOMIC_OFFSET_$$eigenIntervals == _offset);



var _WRITE_VALUE_$$eigenIntervals: bv32;

var _WRITE_READ_BENIGN_FLAG_$$eigenIntervals: bool;

procedure {:inline 1} _LOG_WRITE_$$eigenIntervals(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32);
  modifies _WRITE_HAS_OCCURRED_$$eigenIntervals, _WRITE_OFFSET_$$eigenIntervals, _WRITE_VALUE_$$eigenIntervals, _WRITE_READ_BENIGN_FLAG_$$eigenIntervals;



implementation {:inline 1} _LOG_WRITE_$$eigenIntervals(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32)
{
  var track: bool;


  _LOG_WRITE:
    havoc track;
    _WRITE_HAS_OCCURRED_$$eigenIntervals := (if _P && track then true else _WRITE_HAS_OCCURRED_$$eigenIntervals);
    _WRITE_OFFSET_$$eigenIntervals := (if _P && track then _offset else _WRITE_OFFSET_$$eigenIntervals);
    _WRITE_VALUE_$$eigenIntervals := (if _P && track then _value else _WRITE_VALUE_$$eigenIntervals);
    _WRITE_READ_BENIGN_FLAG_$$eigenIntervals := (if _P && track then _value != _value_old else _WRITE_READ_BENIGN_FLAG_$$eigenIntervals);
    return;
}



procedure _CHECK_WRITE_$$eigenIntervals(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "eigenIntervals"} {:array "$$eigenIntervals"} {:race} {:write_write} !(_P && _WRITE_HAS_OCCURRED_$$eigenIntervals && _WRITE_OFFSET_$$eigenIntervals == _offset && _WRITE_VALUE_$$eigenIntervals != _value);
  requires {:original_name "eigenIntervals"} {:array "$$eigenIntervals"} {:race} {:read_write} !(_P && _READ_HAS_OCCURRED_$$eigenIntervals && _READ_OFFSET_$$eigenIntervals == _offset && _READ_VALUE_$$eigenIntervals != _value);
  requires {:original_name "eigenIntervals"} {:array "$$eigenIntervals"} {:race} {:atomic_write} !(_P && _ATOMIC_HAS_OCCURRED_$$eigenIntervals && _ATOMIC_OFFSET_$$eigenIntervals == _offset);



procedure {:inline 1} _LOG_ATOMIC_$$eigenIntervals(_P: bool, _offset: bv32);
  modifies _ATOMIC_HAS_OCCURRED_$$eigenIntervals, _ATOMIC_OFFSET_$$eigenIntervals;



implementation {:inline 1} _LOG_ATOMIC_$$eigenIntervals(_P: bool, _offset: bv32)
{
  var track: bool;


  _LOG_ATOMIC:
    havoc track;
    _ATOMIC_HAS_OCCURRED_$$eigenIntervals := (if _P && track then true else _ATOMIC_HAS_OCCURRED_$$eigenIntervals);
    _ATOMIC_OFFSET_$$eigenIntervals := (if _P && track then _offset else _ATOMIC_OFFSET_$$eigenIntervals);
    return;
}



procedure _CHECK_ATOMIC_$$eigenIntervals(_P: bool, _offset: bv32);
  requires {:original_name "eigenIntervals"} {:array "$$eigenIntervals"} {:race} {:write_atomic} !(_P && _WRITE_HAS_OCCURRED_$$eigenIntervals && _WRITE_OFFSET_$$eigenIntervals == _offset);
  requires {:original_name "eigenIntervals"} {:array "$$eigenIntervals"} {:race} {:read_atomic} !(_P && _READ_HAS_OCCURRED_$$eigenIntervals && _READ_OFFSET_$$eigenIntervals == _offset);



procedure {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$eigenIntervals(_P: bool, _offset: bv32);
  modifies _WRITE_READ_BENIGN_FLAG_$$eigenIntervals;



implementation {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$eigenIntervals(_P: bool, _offset: bv32)
{

  _UPDATE_BENIGN_FLAG:
    _WRITE_READ_BENIGN_FLAG_$$eigenIntervals := (if _P && _WRITE_HAS_OCCURRED_$$eigenIntervals && _WRITE_OFFSET_$$eigenIntervals == _offset then false else _WRITE_READ_BENIGN_FLAG_$$eigenIntervals);
    return;
}



var _READ_VALUE_$$diagonal: bv32;

procedure {:inline 1} _LOG_READ_$$diagonal(_P: bool, _offset: bv32, _value: bv32);
  modifies _READ_HAS_OCCURRED_$$diagonal, _READ_OFFSET_$$diagonal, _READ_VALUE_$$diagonal;



implementation {:inline 1} _LOG_READ_$$diagonal(_P: bool, _offset: bv32, _value: bv32)
{
  var track: bool;


  _LOG_READ:
    havoc track;
    _READ_HAS_OCCURRED_$$diagonal := (if _P && track then true else _READ_HAS_OCCURRED_$$diagonal);
    _READ_OFFSET_$$diagonal := (if _P && track then _offset else _READ_OFFSET_$$diagonal);
    _READ_VALUE_$$diagonal := (if _P && track then _value else _READ_VALUE_$$diagonal);
    return;
}



procedure _CHECK_READ_$$diagonal(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "diagonal"} {:array "$$diagonal"} {:race} {:write_read} !(_P && _WRITE_HAS_OCCURRED_$$diagonal && _WRITE_OFFSET_$$diagonal == _offset && _WRITE_READ_BENIGN_FLAG_$$diagonal);
  requires {:original_name "diagonal"} {:array "$$diagonal"} {:race} {:atomic_read} !(_P && _ATOMIC_HAS_OCCURRED_$$diagonal && _ATOMIC_OFFSET_$$diagonal == _offset);



var _WRITE_VALUE_$$diagonal: bv32;

var _WRITE_READ_BENIGN_FLAG_$$diagonal: bool;

procedure {:inline 1} _LOG_WRITE_$$diagonal(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32);
  modifies _WRITE_HAS_OCCURRED_$$diagonal, _WRITE_OFFSET_$$diagonal, _WRITE_VALUE_$$diagonal, _WRITE_READ_BENIGN_FLAG_$$diagonal;



implementation {:inline 1} _LOG_WRITE_$$diagonal(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32)
{
  var track: bool;


  _LOG_WRITE:
    havoc track;
    _WRITE_HAS_OCCURRED_$$diagonal := (if _P && track then true else _WRITE_HAS_OCCURRED_$$diagonal);
    _WRITE_OFFSET_$$diagonal := (if _P && track then _offset else _WRITE_OFFSET_$$diagonal);
    _WRITE_VALUE_$$diagonal := (if _P && track then _value else _WRITE_VALUE_$$diagonal);
    _WRITE_READ_BENIGN_FLAG_$$diagonal := (if _P && track then _value != _value_old else _WRITE_READ_BENIGN_FLAG_$$diagonal);
    return;
}



procedure _CHECK_WRITE_$$diagonal(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "diagonal"} {:array "$$diagonal"} {:race} {:write_write} !(_P && _WRITE_HAS_OCCURRED_$$diagonal && _WRITE_OFFSET_$$diagonal == _offset && _WRITE_VALUE_$$diagonal != _value);
  requires {:original_name "diagonal"} {:array "$$diagonal"} {:race} {:read_write} !(_P && _READ_HAS_OCCURRED_$$diagonal && _READ_OFFSET_$$diagonal == _offset && _READ_VALUE_$$diagonal != _value);
  requires {:original_name "diagonal"} {:array "$$diagonal"} {:race} {:atomic_write} !(_P && _ATOMIC_HAS_OCCURRED_$$diagonal && _ATOMIC_OFFSET_$$diagonal == _offset);



procedure {:inline 1} _LOG_ATOMIC_$$diagonal(_P: bool, _offset: bv32);
  modifies _ATOMIC_HAS_OCCURRED_$$diagonal, _ATOMIC_OFFSET_$$diagonal;



implementation {:inline 1} _LOG_ATOMIC_$$diagonal(_P: bool, _offset: bv32)
{
  var track: bool;


  _LOG_ATOMIC:
    havoc track;
    _ATOMIC_HAS_OCCURRED_$$diagonal := (if _P && track then true else _ATOMIC_HAS_OCCURRED_$$diagonal);
    _ATOMIC_OFFSET_$$diagonal := (if _P && track then _offset else _ATOMIC_OFFSET_$$diagonal);
    return;
}



procedure _CHECK_ATOMIC_$$diagonal(_P: bool, _offset: bv32);
  requires {:original_name "diagonal"} {:array "$$diagonal"} {:race} {:write_atomic} !(_P && _WRITE_HAS_OCCURRED_$$diagonal && _WRITE_OFFSET_$$diagonal == _offset);
  requires {:original_name "diagonal"} {:array "$$diagonal"} {:race} {:read_atomic} !(_P && _READ_HAS_OCCURRED_$$diagonal && _READ_OFFSET_$$diagonal == _offset);



procedure {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$diagonal(_P: bool, _offset: bv32);
  modifies _WRITE_READ_BENIGN_FLAG_$$diagonal;



implementation {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$diagonal(_P: bool, _offset: bv32)
{

  _UPDATE_BENIGN_FLAG:
    _WRITE_READ_BENIGN_FLAG_$$diagonal := (if _P && _WRITE_HAS_OCCURRED_$$diagonal && _WRITE_OFFSET_$$diagonal == _offset then false else _WRITE_READ_BENIGN_FLAG_$$diagonal);
    return;
}



var _READ_VALUE_$$offDiagonal: bv32;

procedure {:inline 1} _LOG_READ_$$offDiagonal(_P: bool, _offset: bv32, _value: bv32);
  modifies _READ_HAS_OCCURRED_$$offDiagonal, _READ_OFFSET_$$offDiagonal, _READ_VALUE_$$offDiagonal;



implementation {:inline 1} _LOG_READ_$$offDiagonal(_P: bool, _offset: bv32, _value: bv32)
{
  var track: bool;


  _LOG_READ:
    havoc track;
    _READ_HAS_OCCURRED_$$offDiagonal := (if _P && track then true else _READ_HAS_OCCURRED_$$offDiagonal);
    _READ_OFFSET_$$offDiagonal := (if _P && track then _offset else _READ_OFFSET_$$offDiagonal);
    _READ_VALUE_$$offDiagonal := (if _P && track then _value else _READ_VALUE_$$offDiagonal);
    return;
}



procedure _CHECK_READ_$$offDiagonal(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "offDiagonal"} {:array "$$offDiagonal"} {:race} {:write_read} !(_P && _WRITE_HAS_OCCURRED_$$offDiagonal && _WRITE_OFFSET_$$offDiagonal == _offset && _WRITE_READ_BENIGN_FLAG_$$offDiagonal);
  requires {:original_name "offDiagonal"} {:array "$$offDiagonal"} {:race} {:atomic_read} !(_P && _ATOMIC_HAS_OCCURRED_$$offDiagonal && _ATOMIC_OFFSET_$$offDiagonal == _offset);



var _WRITE_VALUE_$$offDiagonal: bv32;

var _WRITE_READ_BENIGN_FLAG_$$offDiagonal: bool;

procedure {:inline 1} _LOG_WRITE_$$offDiagonal(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32);
  modifies _WRITE_HAS_OCCURRED_$$offDiagonal, _WRITE_OFFSET_$$offDiagonal, _WRITE_VALUE_$$offDiagonal, _WRITE_READ_BENIGN_FLAG_$$offDiagonal;



implementation {:inline 1} _LOG_WRITE_$$offDiagonal(_P: bool, _offset: bv32, _value: bv32, _value_old: bv32)
{
  var track: bool;


  _LOG_WRITE:
    havoc track;
    _WRITE_HAS_OCCURRED_$$offDiagonal := (if _P && track then true else _WRITE_HAS_OCCURRED_$$offDiagonal);
    _WRITE_OFFSET_$$offDiagonal := (if _P && track then _offset else _WRITE_OFFSET_$$offDiagonal);
    _WRITE_VALUE_$$offDiagonal := (if _P && track then _value else _WRITE_VALUE_$$offDiagonal);
    _WRITE_READ_BENIGN_FLAG_$$offDiagonal := (if _P && track then _value != _value_old else _WRITE_READ_BENIGN_FLAG_$$offDiagonal);
    return;
}



procedure _CHECK_WRITE_$$offDiagonal(_P: bool, _offset: bv32, _value: bv32);
  requires {:original_name "offDiagonal"} {:array "$$offDiagonal"} {:race} {:write_write} !(_P && _WRITE_HAS_OCCURRED_$$offDiagonal && _WRITE_OFFSET_$$offDiagonal == _offset && _WRITE_VALUE_$$offDiagonal != _value);
  requires {:original_name "offDiagonal"} {:array "$$offDiagonal"} {:race} {:read_write} !(_P && _READ_HAS_OCCURRED_$$offDiagonal && _READ_OFFSET_$$offDiagonal == _offset && _READ_VALUE_$$offDiagonal != _value);
  requires {:original_name "offDiagonal"} {:array "$$offDiagonal"} {:race} {:atomic_write} !(_P && _ATOMIC_HAS_OCCURRED_$$offDiagonal && _ATOMIC_OFFSET_$$offDiagonal == _offset);



procedure {:inline 1} _LOG_ATOMIC_$$offDiagonal(_P: bool, _offset: bv32);
  modifies _ATOMIC_HAS_OCCURRED_$$offDiagonal, _ATOMIC_OFFSET_$$offDiagonal;



implementation {:inline 1} _LOG_ATOMIC_$$offDiagonal(_P: bool, _offset: bv32)
{
  var track: bool;


  _LOG_ATOMIC:
    havoc track;
    _ATOMIC_HAS_OCCURRED_$$offDiagonal := (if _P && track then true else _ATOMIC_HAS_OCCURRED_$$offDiagonal);
    _ATOMIC_OFFSET_$$offDiagonal := (if _P && track then _offset else _ATOMIC_OFFSET_$$offDiagonal);
    return;
}



procedure _CHECK_ATOMIC_$$offDiagonal(_P: bool, _offset: bv32);
  requires {:original_name "offDiagonal"} {:array "$$offDiagonal"} {:race} {:write_atomic} !(_P && _WRITE_HAS_OCCURRED_$$offDiagonal && _WRITE_OFFSET_$$offDiagonal == _offset);
  requires {:original_name "offDiagonal"} {:array "$$offDiagonal"} {:race} {:read_atomic} !(_P && _READ_HAS_OCCURRED_$$offDiagonal && _READ_OFFSET_$$offDiagonal == _offset);



procedure {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$offDiagonal(_P: bool, _offset: bv32);
  modifies _WRITE_READ_BENIGN_FLAG_$$offDiagonal;



implementation {:inline 1} _UPDATE_WRITE_READ_BENIGN_FLAG_$$offDiagonal(_P: bool, _offset: bv32)
{

  _UPDATE_BENIGN_FLAG:
    _WRITE_READ_BENIGN_FLAG_$$offDiagonal := (if _P && _WRITE_HAS_OCCURRED_$$offDiagonal && _WRITE_OFFSET_$$offDiagonal == _offset then false else _WRITE_READ_BENIGN_FLAG_$$offDiagonal);
    return;
}



function {:bvbuiltin "bvsgt"} BV32_SGT(bv32, bv32) : bool;

function {:bvbuiltin "bvsge"} BV32_SGE(bv32, bv32) : bool;

function {:bvbuiltin "bvslt"} BV32_SLT(bv32, bv32) : bool;
